# StoreHarmonyGenerated
Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.1
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/StoreHarmonyGenerated/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->cancelBusiness($storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->cancelBusiness: ', $e->getMessage(), PHP_EOL;
}

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The id of the merchant store to be retrieved

try {
    $result = $apiInstance->loadStoreInfo($storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->loadStoreInfo: ', $e->getMessage(), PHP_EOL;
}

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\Credentials(); // \Swagger\Client\com.storeharmony.api\Credentials | login details of user

try {
    $result = $apiInstance->login($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->login: ', $e->getMessage(), PHP_EOL;
}

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\Registration(); // \Swagger\Client\com.storeharmony.api\Registration | Registration details of user

try {
    $result = $apiInstance->registerBusiness($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->registerBusiness: ', $e->getMessage(), PHP_EOL;
}

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\Registration(); // \Swagger\Client\com.storeharmony.api\Registration | Registration details of user
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->updateBusiness($body, $storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->updateBusiness: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://storeharmony.com/webapi*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*StoreHarmonyAccessApi* | [**cancelBusiness**](docs/Api/StoreHarmonyAccessApi.md#cancelbusiness) | **DELETE** /access/register/{storeid} | requests a deactivation of the account of a store
*StoreHarmonyAccessApi* | [**loadStoreInfo**](docs/Api/StoreHarmonyAccessApi.md#loadstoreinfo) | **GET** /{storeid} | Retrieves a merchant store info from Storeharmony
*StoreHarmonyAccessApi* | [**login**](docs/Api/StoreHarmonyAccessApi.md#login) | **POST** /access | creates a login request to retrieve the authorization token to make calls on behalf of the store
*StoreHarmonyAccessApi* | [**registerBusiness**](docs/Api/StoreHarmonyAccessApi.md#registerbusiness) | **POST** /access/register | register a store on storeharmony
*StoreHarmonyAccessApi* | [**updateBusiness**](docs/Api/StoreHarmonyAccessApi.md#updatebusiness) | **PUT** /access/register/{storeid} | updates a merchant info
*StoreHarmonyContactsApi* | [**createCustomer**](docs/Api/StoreHarmonyContactsApi.md#createcustomer) | **POST** /contact/{storeid} | Create customer contacts for a store merchant
*StoreHarmonyContactsApi* | [**customerReport**](docs/Api/StoreHarmonyContactsApi.md#customerreport) | **GET** /contact/report/{storeid} | Reports on the customer records giving best customer etc
*StoreHarmonyContactsApi* | [**deleteCustomer**](docs/Api/StoreHarmonyContactsApi.md#deletecustomer) | **DELETE** /contact/{storeid}/{customerid} | Deletes a customer contacts details for a store merchant
*StoreHarmonyContactsApi* | [**getCustomer**](docs/Api/StoreHarmonyContactsApi.md#getcustomer) | **GET** /contact/{storeid}/{customerid} | Retrieves a customer contacts details for a store merchant
*StoreHarmonyContactsApi* | [**listCustomer**](docs/Api/StoreHarmonyContactsApi.md#listcustomer) | **GET** /contact/{storeid} | List customer contacts for a store merchant
*StoreHarmonyContactsApi* | [**listCustomerByPage**](docs/Api/StoreHarmonyContactsApi.md#listcustomerbypage) | **GET** /contact/{storeid}/{page}/{size} | List customer contacts for a store merchant
*StoreHarmonyContactsApi* | [**searchCustomer**](docs/Api/StoreHarmonyContactsApi.md#searchcustomer) | **GET** /contact/{storeid}/{search}/{page}/{size} | List customer contacts for a store merchant
*StoreHarmonyContactsApi* | [**updateCustomer**](docs/Api/StoreHarmonyContactsApi.md#updatecustomer) | **PUT** /contact/{storeid}/{customerid} | Updates a customer contacts details for a store merchant
*StoreHarmonyInventoryApi* | [**listStoreInventory**](docs/Api/StoreHarmonyInventoryApi.md#liststoreinventory) | **GET** /{storeid}/inventory | retrieve list of products from the merchant store
*StoreHarmonyInventoryApi* | [**listStoreInventoryPaged**](docs/Api/StoreHarmonyInventoryApi.md#liststoreinventorypaged) | **GET** /{storeid}/{start}/{size} | retrieve list of products from the merchant store
*StoreHarmonyInventoryApi* | [**loadStoreCategories**](docs/Api/StoreHarmonyInventoryApi.md#loadstorecategories) | **GET** /{storeid}/categories | retrieve list of products categories from the merchant store
*StoreHarmonyInventoryApi* | [**loadStoreItem**](docs/Api/StoreHarmonyInventoryApi.md#loadstoreitem) | **GET** /{storeid}/{itemid} | retrieve a product from the store getting its price, details and availability
*StoreHarmonyInventoryApi* | [**loadStoreItemBySlug**](docs/Api/StoreHarmonyInventoryApi.md#loadstoreitembyslug) | **GET** /{storeid}/slug/{slug} | retrieve a product from the store getting its price, details and availability via a slug
*StoreHarmonyInventoryApi* | [**loadStoreItemByUniqueId**](docs/Api/StoreHarmonyInventoryApi.md#loadstoreitembyuniqueid) | **GET** /{storeid}/id/{itemid} | retrieve a product from the store getting its price, details and availability
*StoreHarmonyInventoryApi* | [**loadStoreItemsForCategory**](docs/Api/StoreHarmonyInventoryApi.md#loadstoreitemsforcategory) | **GET** /{storeid}/category/{categoryid} | searches and retrieves a list of products from the merchant store for category
*StoreHarmonyInventoryApi* | [**loadStoreItemsForCategoryByPages**](docs/Api/StoreHarmonyInventoryApi.md#loadstoreitemsforcategorybypages) | **GET** /{storeid}/category/{categoryid}/{start}/{size} | searches and retrieves a list of products from the merchant store
*StoreHarmonyInventoryApi* | [**searchStoreRecords**](docs/Api/StoreHarmonyInventoryApi.md#searchstorerecords) | **GET** /{storeid}/{query}/{start}/{size} | searches and retrieves a list of products from the merchant store
*StoreHarmonyInventoryApi* | [**searchStoreRecordsMore**](docs/Api/StoreHarmonyInventoryApi.md#searchstorerecordsmore) | **POST** /{storeid}/search | retrieve list of products from the merchant store
*StoreHarmonyOrderingApi* | [**loadDeliveryServices**](docs/Api/StoreHarmonyOrderingApi.md#loaddeliveryservices) | **GET** /{storeid}/delivery_services | retrieves the list of delivery services according to the zones supported by the store
*StoreHarmonyOrderingApi* | [**payForOrderViaCustomGateway**](docs/Api/StoreHarmonyOrderingApi.md#payfororderviacustomgateway) | **POST** /{storeid}/order/pay | After an order has been placed and created with Storeharmony, the client can retrieve the order ID and use it to generate payment reference on their custom gateway implementation. They can use this call to pass the reference back to the storeharmony to use to verify the payment has been made. Popular gateways supported includes &#x27;pastack&#x27;, &#x27;flutterwave&#x27;, &#x27;global accelerex&#x27;, &#x27;sterling&#x27;
*StoreHarmonyOrderingApi* | [**payForOrderViaInternalGateway**](docs/Api/StoreHarmonyOrderingApi.md#payfororderviainternalgateway) | **GET** /{storeid}/order/pay/{orderid} | After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment. Gateway settngs are made via customer settings
*StoreHarmonyOrderingApi* | [**placeOrderToStore**](docs/Api/StoreHarmonyOrderingApi.md#placeordertostore) | **POST** /{storeid}/order | places order of listed products to the merchant store. Note that a payment redirect link is also returned which allows the current buyer to make payment into this store if required. An implementation will redirect the customer to this link and later use /storeid/orderid to track the status of payment on this particular order
*StoreHarmonyOrderingApi* | [**verifyOrderPlaced**](docs/Api/StoreHarmonyOrderingApi.md#verifyorderplaced) | **GET** /{storeid}/order/{orderid} | retrieve an Order from the store to check the status

## Documentation For Models

 - [AdvancedQuery](docs/Model/AdvancedQuery.md)
 - [Category](docs/Model/Category.md)
 - [Credentials](docs/Model/Credentials.md)
 - [Customer](docs/Model/Customer.md)
 - [CustomerData](docs/Model/CustomerData.md)
 - [Registration](docs/Model/Registration.md)
 - [WebOrder](docs/Model/WebOrder.md)
 - [WebOrderItem](docs/Model/WebOrderItem.md)
 - [WebOrderPayment](docs/Model/WebOrderPayment.md)
 - [WebProduct](docs/Model/WebProduct.md)
 - [WebStore](docs/Model/WebStore.md)
 - [WebStoreDetails](docs/Model/WebStoreDetails.md)
 - [WebStoreItem](docs/Model/WebStoreItem.md)
 - [WebSubProduct](docs/Model/WebSubProduct.md)

## Documentation For Authorization


## apikey

- **Type**: HTTP bearer authentication


## Author



