# Swagger\Client\StoreHarmonyAccessApi

All URIs are relative to *https://storeharmony.com/webapi*

Method | HTTP request | Description
------------- | ------------- | -------------
[**cancelBusiness**](StoreHarmonyAccessApi.md#cancelbusiness) | **DELETE** /access/register/{storeid} | requests a deactivation of the account of a store
[**loadStoreInfo**](StoreHarmonyAccessApi.md#loadstoreinfo) | **GET** /{storeid} | Retrieves a merchant store info from Storeharmony
[**login**](StoreHarmonyAccessApi.md#login) | **POST** /access | creates a login request to retrieve the authorization token to make calls on behalf of the store
[**registerBusiness**](StoreHarmonyAccessApi.md#registerbusiness) | **POST** /access/register | register a store on storeharmony
[**updateBusiness**](StoreHarmonyAccessApi.md#updatebusiness) | **PUT** /access/register/{storeid} | updates a merchant info

# **cancelBusiness**
> \Swagger\Client\com.storeharmony.api\WebStore cancelBusiness($storeid)

requests a deactivation of the account of a store

Enables a user request a cancellation of their storeharmony account

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->cancelBusiness($storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->cancelBusiness: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **loadStoreInfo**
> \Swagger\Client\com.storeharmony.api\WebStore loadStoreInfo($storeid)

Retrieves a merchant store info from Storeharmony

To access details about the merchant being integrated with, call this method passing the merchant store id as generated by storeharmony and provided per merchant store

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The id of the merchant store to be retrieved

try {
    $result = $apiInstance->loadStoreInfo($storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->loadStoreInfo: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The id of the merchant store to be retrieved |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **login**
> \Swagger\Client\com.storeharmony.api\WebStore login($body)

creates a login request to retrieve the authorization token to make calls on behalf of the store

Enables a user create a login request to retrieve the authorization token to make calls on behalf of the store

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\Credentials(); // \Swagger\Client\com.storeharmony.api\Credentials | login details of user

try {
    $result = $apiInstance->login($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->login: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\com.storeharmony.api\Credentials**](../Model/Credentials.md)| login details of user |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **registerBusiness**
> \Swagger\Client\com.storeharmony.api\WebStore registerBusiness($body)

register a store on storeharmony

With an upgraded referral code, a store can be created on storeharmony from any external entity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\Registration(); // \Swagger\Client\com.storeharmony.api\Registration | Registration details of user

try {
    $result = $apiInstance->registerBusiness($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->registerBusiness: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\com.storeharmony.api\Registration**](../Model/Registration.md)| Registration details of user |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **updateBusiness**
> \Swagger\Client\com.storeharmony.api\WebStore updateBusiness($body, $storeid)

updates a merchant info

Enable update of a merchant info

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyAccessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\Registration(); // \Swagger\Client\com.storeharmony.api\Registration | Registration details of user
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->updateBusiness($body, $storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyAccessApi->updateBusiness: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\com.storeharmony.api\Registration**](../Model/Registration.md)| Registration details of user |
 **storeid** | **string**| The store id of the specific store |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

