# Swagger\Client\StoreHarmonyContactsApi

All URIs are relative to *https://storeharmony.com/webapi*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createCustomer**](StoreHarmonyContactsApi.md#createcustomer) | **POST** /contact/{storeid} | Create customer contacts for a store merchant
[**customerReport**](StoreHarmonyContactsApi.md#customerreport) | **GET** /contact/report/{storeid} | Reports on the customer records giving best customer etc
[**deleteCustomer**](StoreHarmonyContactsApi.md#deletecustomer) | **DELETE** /contact/{storeid}/{customerid} | Deletes a customer contacts details for a store merchant
[**getCustomer**](StoreHarmonyContactsApi.md#getcustomer) | **GET** /contact/{storeid}/{customerid} | Retrieves a customer contacts details for a store merchant
[**listCustomer**](StoreHarmonyContactsApi.md#listcustomer) | **GET** /contact/{storeid} | List customer contacts for a store merchant
[**listCustomerByPage**](StoreHarmonyContactsApi.md#listcustomerbypage) | **GET** /contact/{storeid}/{page}/{size} | List customer contacts for a store merchant
[**searchCustomer**](StoreHarmonyContactsApi.md#searchcustomer) | **GET** /contact/{storeid}/{search}/{page}/{size} | List customer contacts for a store merchant
[**updateCustomer**](StoreHarmonyContactsApi.md#updatecustomer) | **PUT** /contact/{storeid}/{customerid} | Updates a customer contacts details for a store merchant

# **createCustomer**
> \Swagger\Client\com.storeharmony.api\CustomerData createCustomer($body, $storeid)

Create customer contacts for a store merchant

Create a customer information for the merchant

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyContactsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\Customer(); // \Swagger\Client\com.storeharmony.api\Customer | Customer contact details
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->createCustomer($body, $storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyContactsApi->createCustomer: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\com.storeharmony.api\Customer**](../Model/Customer.md)| Customer contact details |
 **storeid** | **string**| The store id of the specific store |

### Return type

[**\Swagger\Client\com.storeharmony.api\CustomerData**](../Model/CustomerData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **customerReport**
> \Swagger\Client\com.storeharmony.api\CustomerData customerReport($storeid)

Reports on the customer records giving best customer etc

Returns a basic report on customer

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyContactsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->customerReport($storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyContactsApi->customerReport: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |

### Return type

[**\Swagger\Client\com.storeharmony.api\CustomerData**](../Model/CustomerData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteCustomer**
> \Swagger\Client\com.storeharmony.api\Customer deleteCustomer($storeid, $customerid)

Deletes a customer contacts details for a store merchant

Deletes a customer of the merchant accouunt with provided ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyContactsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$customerid = "customerid_example"; // string | The customerid id of the contact

try {
    $result = $apiInstance->deleteCustomer($storeid, $customerid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyContactsApi->deleteCustomer: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **customerid** | **string**| The customerid id of the contact |

### Return type

[**\Swagger\Client\com.storeharmony.api\Customer**](../Model/Customer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getCustomer**
> \Swagger\Client\com.storeharmony.api\Customer getCustomer($storeid, $customerid)

Retrieves a customer contacts details for a store merchant

Retrieves a customer of the merchant accouunt with provided ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyContactsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$customerid = "customerid_example"; // string | The customerid id of the contact

try {
    $result = $apiInstance->getCustomer($storeid, $customerid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyContactsApi->getCustomer: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **customerid** | **string**| The customerid id of the contact |

### Return type

[**\Swagger\Client\com.storeharmony.api\Customer**](../Model/Customer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **listCustomer**
> \Swagger\Client\com.storeharmony.api\CustomerData listCustomer($storeid)

List customer contacts for a store merchant

Returns the list of contacts for a merchant accouunt

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyContactsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->listCustomer($storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyContactsApi->listCustomer: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |

### Return type

[**\Swagger\Client\com.storeharmony.api\CustomerData**](../Model/CustomerData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **listCustomerByPage**
> \Swagger\Client\com.storeharmony.api\CustomerData listCustomerByPage($storeid, $page, $size)

List customer contacts for a store merchant

Returns the list of contacts for a merchant accouunt

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyContactsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$page = "page_example"; // string | page number to start listing
$size = "size_example"; // string | size of records to list

try {
    $result = $apiInstance->listCustomerByPage($storeid, $page, $size);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyContactsApi->listCustomerByPage: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **page** | **string**| page number to start listing |
 **size** | **string**| size of records to list |

### Return type

[**\Swagger\Client\com.storeharmony.api\CustomerData**](../Model/CustomerData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **searchCustomer**
> \Swagger\Client\com.storeharmony.api\CustomerData searchCustomer($storeid, $search, $page, $size)

List customer contacts for a store merchant

Returns the list of contacts for a merchant accouunt

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyContactsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$search = "search_example"; // string | The search query
$page = "page_example"; // string | page number to start listing
$size = "size_example"; // string | size of records to list

try {
    $result = $apiInstance->searchCustomer($storeid, $search, $page, $size);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyContactsApi->searchCustomer: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **search** | **string**| The search query |
 **page** | **string**| page number to start listing |
 **size** | **string**| size of records to list |

### Return type

[**\Swagger\Client\com.storeharmony.api\CustomerData**](../Model/CustomerData.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **updateCustomer**
> \Swagger\Client\com.storeharmony.api\Customer updateCustomer($body, $storeid, $customerid)

Updates a customer contacts details for a store merchant

Updates a customer of the merchant accouunt with provided ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyContactsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\Customer(); // \Swagger\Client\com.storeharmony.api\Customer | Customer contact details
$storeid = "storeid_example"; // string | The store id of the specific store
$customerid = "customerid_example"; // string | The customerid id of the contact

try {
    $result = $apiInstance->updateCustomer($body, $storeid, $customerid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyContactsApi->updateCustomer: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\com.storeharmony.api\Customer**](../Model/Customer.md)| Customer contact details |
 **storeid** | **string**| The store id of the specific store |
 **customerid** | **string**| The customerid id of the contact |

### Return type

[**\Swagger\Client\com.storeharmony.api\Customer**](../Model/Customer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

