# Swagger\Client\StoreHarmonyInventoryApi

All URIs are relative to *https://storeharmony.com/webapi*

Method | HTTP request | Description
------------- | ------------- | -------------
[**listStoreInventory**](StoreHarmonyInventoryApi.md#liststoreinventory) | **GET** /{storeid}/inventory | retrieve list of products from the merchant store
[**listStoreInventoryPaged**](StoreHarmonyInventoryApi.md#liststoreinventorypaged) | **GET** /{storeid}/{start}/{size} | retrieve list of products from the merchant store
[**loadStoreCategories**](StoreHarmonyInventoryApi.md#loadstorecategories) | **GET** /{storeid}/categories | retrieve list of products categories from the merchant store
[**loadStoreItem**](StoreHarmonyInventoryApi.md#loadstoreitem) | **GET** /{storeid}/{itemid} | retrieve a product from the store getting its price, details and availability
[**loadStoreItemBySlug**](StoreHarmonyInventoryApi.md#loadstoreitembyslug) | **GET** /{storeid}/slug/{slug} | retrieve a product from the store getting its price, details and availability via a slug
[**loadStoreItemByUniqueId**](StoreHarmonyInventoryApi.md#loadstoreitembyuniqueid) | **GET** /{storeid}/id/{itemid} | retrieve a product from the store getting its price, details and availability
[**loadStoreItemsForCategory**](StoreHarmonyInventoryApi.md#loadstoreitemsforcategory) | **GET** /{storeid}/category/{categoryid} | searches and retrieves a list of products from the merchant store for category
[**loadStoreItemsForCategoryByPages**](StoreHarmonyInventoryApi.md#loadstoreitemsforcategorybypages) | **GET** /{storeid}/category/{categoryid}/{start}/{size} | searches and retrieves a list of products from the merchant store
[**searchStoreRecords**](StoreHarmonyInventoryApi.md#searchstorerecords) | **GET** /{storeid}/{query}/{start}/{size} | searches and retrieves a list of products from the merchant store
[**searchStoreRecordsMore**](StoreHarmonyInventoryApi.md#searchstorerecordsmore) | **POST** /{storeid}/search | retrieve list of products from the merchant store

# **listStoreInventory**
> \Swagger\Client\com.storeharmony.api\WebStore listStoreInventory($storeid)

retrieve list of products from the merchant store

Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->listStoreInventory($storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->listStoreInventory: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **listStoreInventoryPaged**
> \Swagger\Client\com.storeharmony.api\WebStore listStoreInventoryPaged($storeid, $start, $size)

retrieve list of products from the merchant store

Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$start = "start_example"; // string | The start of page of listed products
$size = "size_example"; // string | The size of page of listed products

try {
    $result = $apiInstance->listStoreInventoryPaged($storeid, $start, $size);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->listStoreInventoryPaged: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **start** | **string**| The start of page of listed products |
 **size** | **string**| The size of page of listed products |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **loadStoreCategories**
> \Swagger\Client\com.storeharmony.api\WebStore loadStoreCategories($storeid)

retrieve list of products categories from the merchant store

Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->loadStoreCategories($storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->loadStoreCategories: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **loadStoreItem**
> \Swagger\Client\com.storeharmony.api\WebStore loadStoreItem($storeid, $itemid)

retrieve a product from the store getting its price, details and availability

Returns the details about a store product which can be connected to a payment process or checkout process

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$itemid = "itemid_example"; // string | The itemid carrying the ID or slug of the product being loaded

try {
    $result = $apiInstance->loadStoreItem($storeid, $itemid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->loadStoreItem: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **itemid** | **string**| The itemid carrying the ID or slug of the product being loaded |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **loadStoreItemBySlug**
> \Swagger\Client\com.storeharmony.api\WebStore loadStoreItemBySlug($storeid, $slug)

retrieve a product from the store getting its price, details and availability via a slug

Returns the details about a store product usnig its slug

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$slug = "slug_example"; // string | The slug carrying the ID or slug of the product being loaded

try {
    $result = $apiInstance->loadStoreItemBySlug($storeid, $slug);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->loadStoreItemBySlug: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **slug** | **string**| The slug carrying the ID or slug of the product being loaded |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **loadStoreItemByUniqueId**
> \Swagger\Client\com.storeharmony.api\WebStore loadStoreItemByUniqueId($storeid, $itemid)

retrieve a product from the store getting its price, details and availability

Returns the details about a store product usnig its universal ID

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$itemid = "itemid_example"; // string | The itemid carrying the ID or slug of the product being loaded

try {
    $result = $apiInstance->loadStoreItemByUniqueId($storeid, $itemid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->loadStoreItemByUniqueId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **itemid** | **string**| The itemid carrying the ID or slug of the product being loaded |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **loadStoreItemsForCategory**
> \Swagger\Client\com.storeharmony.api\WebStore loadStoreItemsForCategory($storeid, $categoryid)

searches and retrieves a list of products from the merchant store for category

Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity under a category

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$categoryid = "categoryid_example"; // string | The category id returned from categories call. See /storeid/categories

try {
    $result = $apiInstance->loadStoreItemsForCategory($storeid, $categoryid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->loadStoreItemsForCategory: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **categoryid** | **string**| The category id returned from categories call. See /storeid/categories |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **loadStoreItemsForCategoryByPages**
> \Swagger\Client\com.storeharmony.api\WebStore loadStoreItemsForCategoryByPages($storeid, $categoryid, $start, $size)

searches and retrieves a list of products from the merchant store

Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$categoryid = "categoryid_example"; // string | The categoryid of the category
$start = "start_example"; // string | The start of page of listed products
$size = "size_example"; // string | The size of page of listed products

try {
    $result = $apiInstance->loadStoreItemsForCategoryByPages($storeid, $categoryid, $start, $size);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->loadStoreItemsForCategoryByPages: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **categoryid** | **string**| The categoryid of the category |
 **start** | **string**| The start of page of listed products |
 **size** | **string**| The size of page of listed products |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **searchStoreRecords**
> \Swagger\Client\com.storeharmony.api\WebStore searchStoreRecords($storeid, $query, $start, $size)

searches and retrieves a list of products from the merchant store

Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$storeid = "storeid_example"; // string | The store id of the specific store
$query = "query_example"; // string | The query string
$start = "start_example"; // string | The start of page of listed products
$size = "size_example"; // string | The size of page of listed products

try {
    $result = $apiInstance->searchStoreRecords($storeid, $query, $start, $size);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->searchStoreRecords: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storeid** | **string**| The store id of the specific store |
 **query** | **string**| The query string |
 **start** | **string**| The start of page of listed products |
 **size** | **string**| The size of page of listed products |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **searchStoreRecordsMore**
> \Swagger\Client\com.storeharmony.api\WebStore searchStoreRecordsMore($body, $storeid)

retrieve list of products from the merchant store

Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\com.storeharmony.api\StoreHarmonyInventoryApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\com.storeharmony.api\AdvancedQuery(); // \Swagger\Client\com.storeharmony.api\AdvancedQuery | unique identifier of inventory item
$storeid = "storeid_example"; // string | The store id of the specific store

try {
    $result = $apiInstance->searchStoreRecordsMore($body, $storeid);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling StoreHarmonyInventoryApi->searchStoreRecordsMore: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\com.storeharmony.api\AdvancedQuery**](../Model/AdvancedQuery.md)| unique identifier of inventory item |
 **storeid** | **string**| The store id of the specific store |

### Return type

[**\Swagger\Client\com.storeharmony.api\WebStore**](../Model/WebStore.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

