<?php
/**
 * AdvancedQuery
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Store Harmony v3 Merchant API
 *
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)
 *
 * OpenAPI spec version: 1.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\com.storeharmony.api;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * AdvancedQuery Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class AdvancedQuery implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'AdvancedQuery';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'query' => 'string',
'pagesize' => 'int',
'page' => 'int',
'startdate' => 'string',
'enddate' => 'string',
'customer_id' => 'string',
'xpath' => 'string',
'category' => 'string',
'filter' => 'string',
'sort' => 'string',
'persist' => 'bool',
'query_title' => 'string'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'query' => null,
'pagesize' => null,
'page' => null,
'startdate' => null,
'enddate' => null,
'customer_id' => null,
'xpath' => null,
'category' => null,
'filter' => null,
'sort' => null,
'persist' => null,
'query_title' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'query' => 'query',
'pagesize' => 'pagesize',
'page' => 'page',
'startdate' => 'startdate',
'enddate' => 'enddate',
'customer_id' => 'customerId',
'xpath' => 'xpath',
'category' => 'category',
'filter' => 'filter',
'sort' => 'sort',
'persist' => 'persist',
'query_title' => 'queryTitle'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'query' => 'setQuery',
'pagesize' => 'setPagesize',
'page' => 'setPage',
'startdate' => 'setStartdate',
'enddate' => 'setEnddate',
'customer_id' => 'setCustomerId',
'xpath' => 'setXpath',
'category' => 'setCategory',
'filter' => 'setFilter',
'sort' => 'setSort',
'persist' => 'setPersist',
'query_title' => 'setQueryTitle'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'query' => 'getQuery',
'pagesize' => 'getPagesize',
'page' => 'getPage',
'startdate' => 'getStartdate',
'enddate' => 'getEnddate',
'customer_id' => 'getCustomerId',
'xpath' => 'getXpath',
'category' => 'getCategory',
'filter' => 'getFilter',
'sort' => 'getSort',
'persist' => 'getPersist',
'query_title' => 'getQueryTitle'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['query'] = isset($data['query']) ? $data['query'] : null;
        $this->container['pagesize'] = isset($data['pagesize']) ? $data['pagesize'] : null;
        $this->container['page'] = isset($data['page']) ? $data['page'] : null;
        $this->container['startdate'] = isset($data['startdate']) ? $data['startdate'] : null;
        $this->container['enddate'] = isset($data['enddate']) ? $data['enddate'] : null;
        $this->container['customer_id'] = isset($data['customer_id']) ? $data['customer_id'] : null;
        $this->container['xpath'] = isset($data['xpath']) ? $data['xpath'] : null;
        $this->container['category'] = isset($data['category']) ? $data['category'] : null;
        $this->container['filter'] = isset($data['filter']) ? $data['filter'] : null;
        $this->container['sort'] = isset($data['sort']) ? $data['sort'] : null;
        $this->container['persist'] = isset($data['persist']) ? $data['persist'] : null;
        $this->container['query_title'] = isset($data['query_title']) ? $data['query_title'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets query
     *
     * @return string
     */
    public function getQuery()
    {
        return $this->container['query'];
    }

    /**
     * Sets query
     *
     * @param string $query holds value for query
     *
     * @return $this
     */
    public function setQuery($query)
    {
        $this->container['query'] = $query;

        return $this;
    }

    /**
     * Gets pagesize
     *
     * @return int
     */
    public function getPagesize()
    {
        return $this->container['pagesize'];
    }

    /**
     * Sets pagesize
     *
     * @param int $pagesize holds value for pagesize
     *
     * @return $this
     */
    public function setPagesize($pagesize)
    {
        $this->container['pagesize'] = $pagesize;

        return $this;
    }

    /**
     * Gets page
     *
     * @return int
     */
    public function getPage()
    {
        return $this->container['page'];
    }

    /**
     * Sets page
     *
     * @param int $page holds value for page
     *
     * @return $this
     */
    public function setPage($page)
    {
        $this->container['page'] = $page;

        return $this;
    }

    /**
     * Gets startdate
     *
     * @return string
     */
    public function getStartdate()
    {
        return $this->container['startdate'];
    }

    /**
     * Sets startdate
     *
     * @param string $startdate holds value for startdate
     *
     * @return $this
     */
    public function setStartdate($startdate)
    {
        $this->container['startdate'] = $startdate;

        return $this;
    }

    /**
     * Gets enddate
     *
     * @return string
     */
    public function getEnddate()
    {
        return $this->container['enddate'];
    }

    /**
     * Sets enddate
     *
     * @param string $enddate holds value for enddate
     *
     * @return $this
     */
    public function setEnddate($enddate)
    {
        $this->container['enddate'] = $enddate;

        return $this;
    }

    /**
     * Gets customer_id
     *
     * @return string
     */
    public function getCustomerId()
    {
        return $this->container['customer_id'];
    }

    /**
     * Sets customer_id
     *
     * @param string $customer_id holds value for customerId
     *
     * @return $this
     */
    public function setCustomerId($customer_id)
    {
        $this->container['customer_id'] = $customer_id;

        return $this;
    }

    /**
     * Gets xpath
     *
     * @return string
     */
    public function getXpath()
    {
        return $this->container['xpath'];
    }

    /**
     * Sets xpath
     *
     * @param string $xpath holds value for xpath
     *
     * @return $this
     */
    public function setXpath($xpath)
    {
        $this->container['xpath'] = $xpath;

        return $this;
    }

    /**
     * Gets category
     *
     * @return string
     */
    public function getCategory()
    {
        return $this->container['category'];
    }

    /**
     * Sets category
     *
     * @param string $category holds value for category
     *
     * @return $this
     */
    public function setCategory($category)
    {
        $this->container['category'] = $category;

        return $this;
    }

    /**
     * Gets filter
     *
     * @return string
     */
    public function getFilter()
    {
        return $this->container['filter'];
    }

    /**
     * Sets filter
     *
     * @param string $filter holds value for filter
     *
     * @return $this
     */
    public function setFilter($filter)
    {
        $this->container['filter'] = $filter;

        return $this;
    }

    /**
     * Gets sort
     *
     * @return string
     */
    public function getSort()
    {
        return $this->container['sort'];
    }

    /**
     * Sets sort
     *
     * @param string $sort holds value for sort
     *
     * @return $this
     */
    public function setSort($sort)
    {
        $this->container['sort'] = $sort;

        return $this;
    }

    /**
     * Gets persist
     *
     * @return bool
     */
    public function getPersist()
    {
        return $this->container['persist'];
    }

    /**
     * Sets persist
     *
     * @param bool $persist holds value for persist
     *
     * @return $this
     */
    public function setPersist($persist)
    {
        $this->container['persist'] = $persist;

        return $this;
    }

    /**
     * Gets query_title
     *
     * @return string
     */
    public function getQueryTitle()
    {
        return $this->container['query_title'];
    }

    /**
     * Sets query_title
     *
     * @param string $query_title holds value for queryTitle
     *
     * @return $this
     */
    public function setQueryTitle($query_title)
    {
        $this->container['query_title'] = $query_title;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
