<?php
/**
 * Customer
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Store Harmony v3 Merchant API
 *
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)
 *
 * OpenAPI spec version: 1.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\com.storeharmony.api;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * Customer Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class Customer implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'Customer';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'success' => 'bool',
'message' => 'string',
'customer_id' => 'string',
'loyalty_card_no' => 'string',
'web_channel_id' => 'string',
'firstname' => 'string',
'lastname' => 'string',
'mobile' => 'string',
'state' => 'string',
'country' => 'string',
'email' => 'string',
'delivery_address' => 'string',
'photo_id' => 'string',
'general_prefs' => 'string',
'birthday_month' => 'int',
'birthday_date' => 'int',
'birthday_year' => 'int',
'gender' => 'string',
'activated' => 'bool',
'mobile_verified' => 'bool',
'email_verified' => 'bool',
'last_visit_date' => 'string',
'register_date' => 'string'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'success' => null,
'message' => null,
'customer_id' => null,
'loyalty_card_no' => null,
'web_channel_id' => null,
'firstname' => null,
'lastname' => null,
'mobile' => null,
'state' => null,
'country' => null,
'email' => null,
'delivery_address' => null,
'photo_id' => null,
'general_prefs' => null,
'birthday_month' => null,
'birthday_date' => null,
'birthday_year' => null,
'gender' => null,
'activated' => null,
'mobile_verified' => null,
'email_verified' => null,
'last_visit_date' => null,
'register_date' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'success' => 'success',
'message' => 'message',
'customer_id' => 'customerId',
'loyalty_card_no' => 'loyaltyCardNo',
'web_channel_id' => 'webChannelId',
'firstname' => 'firstname',
'lastname' => 'lastname',
'mobile' => 'mobile',
'state' => 'state',
'country' => 'country',
'email' => 'email',
'delivery_address' => 'deliveryAddress',
'photo_id' => 'photoId',
'general_prefs' => 'generalPrefs',
'birthday_month' => 'birthdayMonth',
'birthday_date' => 'birthdayDate',
'birthday_year' => 'birthdayYear',
'gender' => 'gender',
'activated' => 'activated',
'mobile_verified' => 'mobileVerified',
'email_verified' => 'emailVerified',
'last_visit_date' => 'lastVisitDate',
'register_date' => 'registerDate'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'success' => 'setSuccess',
'message' => 'setMessage',
'customer_id' => 'setCustomerId',
'loyalty_card_no' => 'setLoyaltyCardNo',
'web_channel_id' => 'setWebChannelId',
'firstname' => 'setFirstname',
'lastname' => 'setLastname',
'mobile' => 'setMobile',
'state' => 'setState',
'country' => 'setCountry',
'email' => 'setEmail',
'delivery_address' => 'setDeliveryAddress',
'photo_id' => 'setPhotoId',
'general_prefs' => 'setGeneralPrefs',
'birthday_month' => 'setBirthdayMonth',
'birthday_date' => 'setBirthdayDate',
'birthday_year' => 'setBirthdayYear',
'gender' => 'setGender',
'activated' => 'setActivated',
'mobile_verified' => 'setMobileVerified',
'email_verified' => 'setEmailVerified',
'last_visit_date' => 'setLastVisitDate',
'register_date' => 'setRegisterDate'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'success' => 'getSuccess',
'message' => 'getMessage',
'customer_id' => 'getCustomerId',
'loyalty_card_no' => 'getLoyaltyCardNo',
'web_channel_id' => 'getWebChannelId',
'firstname' => 'getFirstname',
'lastname' => 'getLastname',
'mobile' => 'getMobile',
'state' => 'getState',
'country' => 'getCountry',
'email' => 'getEmail',
'delivery_address' => 'getDeliveryAddress',
'photo_id' => 'getPhotoId',
'general_prefs' => 'getGeneralPrefs',
'birthday_month' => 'getBirthdayMonth',
'birthday_date' => 'getBirthdayDate',
'birthday_year' => 'getBirthdayYear',
'gender' => 'getGender',
'activated' => 'getActivated',
'mobile_verified' => 'getMobileVerified',
'email_verified' => 'getEmailVerified',
'last_visit_date' => 'getLastVisitDate',
'register_date' => 'getRegisterDate'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['success'] = isset($data['success']) ? $data['success'] : null;
        $this->container['message'] = isset($data['message']) ? $data['message'] : null;
        $this->container['customer_id'] = isset($data['customer_id']) ? $data['customer_id'] : null;
        $this->container['loyalty_card_no'] = isset($data['loyalty_card_no']) ? $data['loyalty_card_no'] : null;
        $this->container['web_channel_id'] = isset($data['web_channel_id']) ? $data['web_channel_id'] : null;
        $this->container['firstname'] = isset($data['firstname']) ? $data['firstname'] : null;
        $this->container['lastname'] = isset($data['lastname']) ? $data['lastname'] : null;
        $this->container['mobile'] = isset($data['mobile']) ? $data['mobile'] : null;
        $this->container['state'] = isset($data['state']) ? $data['state'] : null;
        $this->container['country'] = isset($data['country']) ? $data['country'] : null;
        $this->container['email'] = isset($data['email']) ? $data['email'] : null;
        $this->container['delivery_address'] = isset($data['delivery_address']) ? $data['delivery_address'] : null;
        $this->container['photo_id'] = isset($data['photo_id']) ? $data['photo_id'] : null;
        $this->container['general_prefs'] = isset($data['general_prefs']) ? $data['general_prefs'] : null;
        $this->container['birthday_month'] = isset($data['birthday_month']) ? $data['birthday_month'] : null;
        $this->container['birthday_date'] = isset($data['birthday_date']) ? $data['birthday_date'] : null;
        $this->container['birthday_year'] = isset($data['birthday_year']) ? $data['birthday_year'] : null;
        $this->container['gender'] = isset($data['gender']) ? $data['gender'] : null;
        $this->container['activated'] = isset($data['activated']) ? $data['activated'] : null;
        $this->container['mobile_verified'] = isset($data['mobile_verified']) ? $data['mobile_verified'] : null;
        $this->container['email_verified'] = isset($data['email_verified']) ? $data['email_verified'] : null;
        $this->container['last_visit_date'] = isset($data['last_visit_date']) ? $data['last_visit_date'] : null;
        $this->container['register_date'] = isset($data['register_date']) ? $data['register_date'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets success
     *
     * @return bool
     */
    public function getSuccess()
    {
        return $this->container['success'];
    }

    /**
     * Sets success
     *
     * @param bool $success holds value for success
     *
     * @return $this
     */
    public function setSuccess($success)
    {
        $this->container['success'] = $success;

        return $this;
    }

    /**
     * Gets message
     *
     * @return string
     */
    public function getMessage()
    {
        return $this->container['message'];
    }

    /**
     * Sets message
     *
     * @param string $message holds value for message
     *
     * @return $this
     */
    public function setMessage($message)
    {
        $this->container['message'] = $message;

        return $this;
    }

    /**
     * Gets customer_id
     *
     * @return string
     */
    public function getCustomerId()
    {
        return $this->container['customer_id'];
    }

    /**
     * Sets customer_id
     *
     * @param string $customer_id holds value for customerId
     *
     * @return $this
     */
    public function setCustomerId($customer_id)
    {
        $this->container['customer_id'] = $customer_id;

        return $this;
    }

    /**
     * Gets loyalty_card_no
     *
     * @return string
     */
    public function getLoyaltyCardNo()
    {
        return $this->container['loyalty_card_no'];
    }

    /**
     * Sets loyalty_card_no
     *
     * @param string $loyalty_card_no holds value for loyaltyCardNo
     *
     * @return $this
     */
    public function setLoyaltyCardNo($loyalty_card_no)
    {
        $this->container['loyalty_card_no'] = $loyalty_card_no;

        return $this;
    }

    /**
     * Gets web_channel_id
     *
     * @return string
     */
    public function getWebChannelId()
    {
        return $this->container['web_channel_id'];
    }

    /**
     * Sets web_channel_id
     *
     * @param string $web_channel_id holds value for webChannelId
     *
     * @return $this
     */
    public function setWebChannelId($web_channel_id)
    {
        $this->container['web_channel_id'] = $web_channel_id;

        return $this;
    }

    /**
     * Gets firstname
     *
     * @return string
     */
    public function getFirstname()
    {
        return $this->container['firstname'];
    }

    /**
     * Sets firstname
     *
     * @param string $firstname holds value for firstname
     *
     * @return $this
     */
    public function setFirstname($firstname)
    {
        $this->container['firstname'] = $firstname;

        return $this;
    }

    /**
     * Gets lastname
     *
     * @return string
     */
    public function getLastname()
    {
        return $this->container['lastname'];
    }

    /**
     * Sets lastname
     *
     * @param string $lastname holds value for lastname
     *
     * @return $this
     */
    public function setLastname($lastname)
    {
        $this->container['lastname'] = $lastname;

        return $this;
    }

    /**
     * Gets mobile
     *
     * @return string
     */
    public function getMobile()
    {
        return $this->container['mobile'];
    }

    /**
     * Sets mobile
     *
     * @param string $mobile holds value for mobile
     *
     * @return $this
     */
    public function setMobile($mobile)
    {
        $this->container['mobile'] = $mobile;

        return $this;
    }

    /**
     * Gets state
     *
     * @return string
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     *
     * @param string $state holds value for state
     *
     * @return $this
     */
    public function setState($state)
    {
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets country
     *
     * @return string
     */
    public function getCountry()
    {
        return $this->container['country'];
    }

    /**
     * Sets country
     *
     * @param string $country holds value for country
     *
     * @return $this
     */
    public function setCountry($country)
    {
        $this->container['country'] = $country;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string $email holds value for email
     *
     * @return $this
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets delivery_address
     *
     * @return string
     */
    public function getDeliveryAddress()
    {
        return $this->container['delivery_address'];
    }

    /**
     * Sets delivery_address
     *
     * @param string $delivery_address holds value for deliveryAddress
     *
     * @return $this
     */
    public function setDeliveryAddress($delivery_address)
    {
        $this->container['delivery_address'] = $delivery_address;

        return $this;
    }

    /**
     * Gets photo_id
     *
     * @return string
     */
    public function getPhotoId()
    {
        return $this->container['photo_id'];
    }

    /**
     * Sets photo_id
     *
     * @param string $photo_id holds value for photoId
     *
     * @return $this
     */
    public function setPhotoId($photo_id)
    {
        $this->container['photo_id'] = $photo_id;

        return $this;
    }

    /**
     * Gets general_prefs
     *
     * @return string
     */
    public function getGeneralPrefs()
    {
        return $this->container['general_prefs'];
    }

    /**
     * Sets general_prefs
     *
     * @param string $general_prefs holds value for generalPrefs
     *
     * @return $this
     */
    public function setGeneralPrefs($general_prefs)
    {
        $this->container['general_prefs'] = $general_prefs;

        return $this;
    }

    /**
     * Gets birthday_month
     *
     * @return int
     */
    public function getBirthdayMonth()
    {
        return $this->container['birthday_month'];
    }

    /**
     * Sets birthday_month
     *
     * @param int $birthday_month holds value for birthdayMonth
     *
     * @return $this
     */
    public function setBirthdayMonth($birthday_month)
    {
        $this->container['birthday_month'] = $birthday_month;

        return $this;
    }

    /**
     * Gets birthday_date
     *
     * @return int
     */
    public function getBirthdayDate()
    {
        return $this->container['birthday_date'];
    }

    /**
     * Sets birthday_date
     *
     * @param int $birthday_date holds value for birthdayDate
     *
     * @return $this
     */
    public function setBirthdayDate($birthday_date)
    {
        $this->container['birthday_date'] = $birthday_date;

        return $this;
    }

    /**
     * Gets birthday_year
     *
     * @return int
     */
    public function getBirthdayYear()
    {
        return $this->container['birthday_year'];
    }

    /**
     * Sets birthday_year
     *
     * @param int $birthday_year holds value for birthdayYear
     *
     * @return $this
     */
    public function setBirthdayYear($birthday_year)
    {
        $this->container['birthday_year'] = $birthday_year;

        return $this;
    }

    /**
     * Gets gender
     *
     * @return string
     */
    public function getGender()
    {
        return $this->container['gender'];
    }

    /**
     * Sets gender
     *
     * @param string $gender holds value for gender
     *
     * @return $this
     */
    public function setGender($gender)
    {
        $this->container['gender'] = $gender;

        return $this;
    }

    /**
     * Gets activated
     *
     * @return bool
     */
    public function getActivated()
    {
        return $this->container['activated'];
    }

    /**
     * Sets activated
     *
     * @param bool $activated holds value for activated
     *
     * @return $this
     */
    public function setActivated($activated)
    {
        $this->container['activated'] = $activated;

        return $this;
    }

    /**
     * Gets mobile_verified
     *
     * @return bool
     */
    public function getMobileVerified()
    {
        return $this->container['mobile_verified'];
    }

    /**
     * Sets mobile_verified
     *
     * @param bool $mobile_verified holds value for mobileVerified
     *
     * @return $this
     */
    public function setMobileVerified($mobile_verified)
    {
        $this->container['mobile_verified'] = $mobile_verified;

        return $this;
    }

    /**
     * Gets email_verified
     *
     * @return bool
     */
    public function getEmailVerified()
    {
        return $this->container['email_verified'];
    }

    /**
     * Sets email_verified
     *
     * @param bool $email_verified holds value for emailVerified
     *
     * @return $this
     */
    public function setEmailVerified($email_verified)
    {
        $this->container['email_verified'] = $email_verified;

        return $this;
    }

    /**
     * Gets last_visit_date
     *
     * @return string
     */
    public function getLastVisitDate()
    {
        return $this->container['last_visit_date'];
    }

    /**
     * Sets last_visit_date
     *
     * @param string $last_visit_date holds value for lastVisitDate
     *
     * @return $this
     */
    public function setLastVisitDate($last_visit_date)
    {
        $this->container['last_visit_date'] = $last_visit_date;

        return $this;
    }

    /**
     * Gets register_date
     *
     * @return string
     */
    public function getRegisterDate()
    {
        return $this->container['register_date'];
    }

    /**
     * Sets register_date
     *
     * @param string $register_date holds value for registerDate
     *
     * @return $this
     */
    public function setRegisterDate($register_date)
    {
        $this->container['register_date'] = $register_date;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
