<?php
/**
 * CustomerData
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Store Harmony v3 Merchant API
 *
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)
 *
 * OpenAPI spec version: 1.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\com.storeharmony.api;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * CustomerData Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CustomerData implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'CustomerData';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'customer_list' => '\Swagger\Client\com.storeharmony.api\Customer[]',
'success' => 'bool',
'total_contacts' => 'int',
'page' => 'int',
'page_size' => 'int',
'best_customer' => '\Swagger\Client\com.storeharmony.api\Customer',
'total_customers' => 'float',
'total_active_customers' => 'float',
'total_new_customers' => 'float'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'customer_list' => null,
'success' => null,
'total_contacts' => null,
'page' => null,
'page_size' => null,
'best_customer' => null,
'total_customers' => null,
'total_active_customers' => null,
'total_new_customers' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'customer_list' => 'customerList',
'success' => 'success',
'total_contacts' => 'totalContacts',
'page' => 'page',
'page_size' => 'pageSize',
'best_customer' => 'bestCustomer',
'total_customers' => 'totalCustomers',
'total_active_customers' => 'totalActiveCustomers',
'total_new_customers' => 'totalNewCustomers'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'customer_list' => 'setCustomerList',
'success' => 'setSuccess',
'total_contacts' => 'setTotalContacts',
'page' => 'setPage',
'page_size' => 'setPageSize',
'best_customer' => 'setBestCustomer',
'total_customers' => 'setTotalCustomers',
'total_active_customers' => 'setTotalActiveCustomers',
'total_new_customers' => 'setTotalNewCustomers'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'customer_list' => 'getCustomerList',
'success' => 'getSuccess',
'total_contacts' => 'getTotalContacts',
'page' => 'getPage',
'page_size' => 'getPageSize',
'best_customer' => 'getBestCustomer',
'total_customers' => 'getTotalCustomers',
'total_active_customers' => 'getTotalActiveCustomers',
'total_new_customers' => 'getTotalNewCustomers'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['customer_list'] = isset($data['customer_list']) ? $data['customer_list'] : null;
        $this->container['success'] = isset($data['success']) ? $data['success'] : null;
        $this->container['total_contacts'] = isset($data['total_contacts']) ? $data['total_contacts'] : null;
        $this->container['page'] = isset($data['page']) ? $data['page'] : null;
        $this->container['page_size'] = isset($data['page_size']) ? $data['page_size'] : null;
        $this->container['best_customer'] = isset($data['best_customer']) ? $data['best_customer'] : null;
        $this->container['total_customers'] = isset($data['total_customers']) ? $data['total_customers'] : null;
        $this->container['total_active_customers'] = isset($data['total_active_customers']) ? $data['total_active_customers'] : null;
        $this->container['total_new_customers'] = isset($data['total_new_customers']) ? $data['total_new_customers'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets customer_list
     *
     * @return \Swagger\Client\com.storeharmony.api\Customer[]
     */
    public function getCustomerList()
    {
        return $this->container['customer_list'];
    }

    /**
     * Sets customer_list
     *
     * @param \Swagger\Client\com.storeharmony.api\Customer[] $customer_list customer_list
     *
     * @return $this
     */
    public function setCustomerList($customer_list)
    {
        $this->container['customer_list'] = $customer_list;

        return $this;
    }

    /**
     * Gets success
     *
     * @return bool
     */
    public function getSuccess()
    {
        return $this->container['success'];
    }

    /**
     * Sets success
     *
     * @param bool $success holds value for success
     *
     * @return $this
     */
    public function setSuccess($success)
    {
        $this->container['success'] = $success;

        return $this;
    }

    /**
     * Gets total_contacts
     *
     * @return int
     */
    public function getTotalContacts()
    {
        return $this->container['total_contacts'];
    }

    /**
     * Sets total_contacts
     *
     * @param int $total_contacts holds value for totalContacts
     *
     * @return $this
     */
    public function setTotalContacts($total_contacts)
    {
        $this->container['total_contacts'] = $total_contacts;

        return $this;
    }

    /**
     * Gets page
     *
     * @return int
     */
    public function getPage()
    {
        return $this->container['page'];
    }

    /**
     * Sets page
     *
     * @param int $page holds value for page
     *
     * @return $this
     */
    public function setPage($page)
    {
        $this->container['page'] = $page;

        return $this;
    }

    /**
     * Gets page_size
     *
     * @return int
     */
    public function getPageSize()
    {
        return $this->container['page_size'];
    }

    /**
     * Sets page_size
     *
     * @param int $page_size holds value for pageSize
     *
     * @return $this
     */
    public function setPageSize($page_size)
    {
        $this->container['page_size'] = $page_size;

        return $this;
    }

    /**
     * Gets best_customer
     *
     * @return \Swagger\Client\com.storeharmony.api\Customer
     */
    public function getBestCustomer()
    {
        return $this->container['best_customer'];
    }

    /**
     * Sets best_customer
     *
     * @param \Swagger\Client\com.storeharmony.api\Customer $best_customer best_customer
     *
     * @return $this
     */
    public function setBestCustomer($best_customer)
    {
        $this->container['best_customer'] = $best_customer;

        return $this;
    }

    /**
     * Gets total_customers
     *
     * @return float
     */
    public function getTotalCustomers()
    {
        return $this->container['total_customers'];
    }

    /**
     * Sets total_customers
     *
     * @param float $total_customers holds value for totalCustomers
     *
     * @return $this
     */
    public function setTotalCustomers($total_customers)
    {
        $this->container['total_customers'] = $total_customers;

        return $this;
    }

    /**
     * Gets total_active_customers
     *
     * @return float
     */
    public function getTotalActiveCustomers()
    {
        return $this->container['total_active_customers'];
    }

    /**
     * Sets total_active_customers
     *
     * @param float $total_active_customers holds value for totalActiveCustomers
     *
     * @return $this
     */
    public function setTotalActiveCustomers($total_active_customers)
    {
        $this->container['total_active_customers'] = $total_active_customers;

        return $this;
    }

    /**
     * Gets total_new_customers
     *
     * @return float
     */
    public function getTotalNewCustomers()
    {
        return $this->container['total_new_customers'];
    }

    /**
     * Sets total_new_customers
     *
     * @param float $total_new_customers holds value for totalNewCustomers
     *
     * @return $this
     */
    public function setTotalNewCustomers($total_new_customers)
    {
        $this->container['total_new_customers'] = $total_new_customers;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
