<?php
/**
 * Registration
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Store Harmony v3 Merchant API
 *
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)
 *
 * OpenAPI spec version: 1.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\com.storeharmony.api;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * Registration Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class Registration implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'Registration';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'account_title' => 'string',
'firstname' => 'string',
'lastname' => 'string',
'mobile' => 'string',
'email' => 'string',
'password' => 'string',
'address' => 'string',
'state' => 'string',
'country' => 'string',
'referral' => 'string',
'facebook_id' => 'string',
'twitter_id' => 'string',
'instagram_id' => 'string',
'currency' => 'string',
'category' => 'string',
'cac_no' => 'string',
'bvn_no' => 'string',
'tin_no' => 'string',
'about_store' => 'string'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'account_title' => null,
'firstname' => null,
'lastname' => null,
'mobile' => null,
'email' => null,
'password' => null,
'address' => null,
'state' => null,
'country' => null,
'referral' => null,
'facebook_id' => null,
'twitter_id' => null,
'instagram_id' => null,
'currency' => null,
'category' => null,
'cac_no' => null,
'bvn_no' => null,
'tin_no' => null,
'about_store' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'account_title' => 'accountTitle',
'firstname' => 'firstname',
'lastname' => 'lastname',
'mobile' => 'mobile',
'email' => 'email',
'password' => 'password',
'address' => 'address',
'state' => 'state',
'country' => 'country',
'referral' => 'referral',
'facebook_id' => 'facebookId',
'twitter_id' => 'twitterId',
'instagram_id' => 'instagramId',
'currency' => 'currency',
'category' => 'category',
'cac_no' => 'cacNo',
'bvn_no' => 'bvnNo',
'tin_no' => 'tinNo',
'about_store' => 'aboutStore'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'account_title' => 'setAccountTitle',
'firstname' => 'setFirstname',
'lastname' => 'setLastname',
'mobile' => 'setMobile',
'email' => 'setEmail',
'password' => 'setPassword',
'address' => 'setAddress',
'state' => 'setState',
'country' => 'setCountry',
'referral' => 'setReferral',
'facebook_id' => 'setFacebookId',
'twitter_id' => 'setTwitterId',
'instagram_id' => 'setInstagramId',
'currency' => 'setCurrency',
'category' => 'setCategory',
'cac_no' => 'setCacNo',
'bvn_no' => 'setBvnNo',
'tin_no' => 'setTinNo',
'about_store' => 'setAboutStore'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'account_title' => 'getAccountTitle',
'firstname' => 'getFirstname',
'lastname' => 'getLastname',
'mobile' => 'getMobile',
'email' => 'getEmail',
'password' => 'getPassword',
'address' => 'getAddress',
'state' => 'getState',
'country' => 'getCountry',
'referral' => 'getReferral',
'facebook_id' => 'getFacebookId',
'twitter_id' => 'getTwitterId',
'instagram_id' => 'getInstagramId',
'currency' => 'getCurrency',
'category' => 'getCategory',
'cac_no' => 'getCacNo',
'bvn_no' => 'getBvnNo',
'tin_no' => 'getTinNo',
'about_store' => 'getAboutStore'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['account_title'] = isset($data['account_title']) ? $data['account_title'] : null;
        $this->container['firstname'] = isset($data['firstname']) ? $data['firstname'] : null;
        $this->container['lastname'] = isset($data['lastname']) ? $data['lastname'] : null;
        $this->container['mobile'] = isset($data['mobile']) ? $data['mobile'] : null;
        $this->container['email'] = isset($data['email']) ? $data['email'] : null;
        $this->container['password'] = isset($data['password']) ? $data['password'] : null;
        $this->container['address'] = isset($data['address']) ? $data['address'] : null;
        $this->container['state'] = isset($data['state']) ? $data['state'] : null;
        $this->container['country'] = isset($data['country']) ? $data['country'] : null;
        $this->container['referral'] = isset($data['referral']) ? $data['referral'] : null;
        $this->container['facebook_id'] = isset($data['facebook_id']) ? $data['facebook_id'] : null;
        $this->container['twitter_id'] = isset($data['twitter_id']) ? $data['twitter_id'] : null;
        $this->container['instagram_id'] = isset($data['instagram_id']) ? $data['instagram_id'] : null;
        $this->container['currency'] = isset($data['currency']) ? $data['currency'] : null;
        $this->container['category'] = isset($data['category']) ? $data['category'] : null;
        $this->container['cac_no'] = isset($data['cac_no']) ? $data['cac_no'] : null;
        $this->container['bvn_no'] = isset($data['bvn_no']) ? $data['bvn_no'] : null;
        $this->container['tin_no'] = isset($data['tin_no']) ? $data['tin_no'] : null;
        $this->container['about_store'] = isset($data['about_store']) ? $data['about_store'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets account_title
     *
     * @return string
     */
    public function getAccountTitle()
    {
        return $this->container['account_title'];
    }

    /**
     * Sets account_title
     *
     * @param string $account_title holds value for accountTitle
     *
     * @return $this
     */
    public function setAccountTitle($account_title)
    {
        $this->container['account_title'] = $account_title;

        return $this;
    }

    /**
     * Gets firstname
     *
     * @return string
     */
    public function getFirstname()
    {
        return $this->container['firstname'];
    }

    /**
     * Sets firstname
     *
     * @param string $firstname holds value for firstname
     *
     * @return $this
     */
    public function setFirstname($firstname)
    {
        $this->container['firstname'] = $firstname;

        return $this;
    }

    /**
     * Gets lastname
     *
     * @return string
     */
    public function getLastname()
    {
        return $this->container['lastname'];
    }

    /**
     * Sets lastname
     *
     * @param string $lastname holds value for lastname
     *
     * @return $this
     */
    public function setLastname($lastname)
    {
        $this->container['lastname'] = $lastname;

        return $this;
    }

    /**
     * Gets mobile
     *
     * @return string
     */
    public function getMobile()
    {
        return $this->container['mobile'];
    }

    /**
     * Sets mobile
     *
     * @param string $mobile holds value for mobile
     *
     * @return $this
     */
    public function setMobile($mobile)
    {
        $this->container['mobile'] = $mobile;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string $email holds value for email
     *
     * @return $this
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets password
     *
     * @return string
     */
    public function getPassword()
    {
        return $this->container['password'];
    }

    /**
     * Sets password
     *
     * @param string $password holds value for password
     *
     * @return $this
     */
    public function setPassword($password)
    {
        $this->container['password'] = $password;

        return $this;
    }

    /**
     * Gets address
     *
     * @return string
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param string $address holds value for address
     *
     * @return $this
     */
    public function setAddress($address)
    {
        $this->container['address'] = $address;

        return $this;
    }

    /**
     * Gets state
     *
     * @return string
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     *
     * @param string $state holds value for state
     *
     * @return $this
     */
    public function setState($state)
    {
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets country
     *
     * @return string
     */
    public function getCountry()
    {
        return $this->container['country'];
    }

    /**
     * Sets country
     *
     * @param string $country holds value for country
     *
     * @return $this
     */
    public function setCountry($country)
    {
        $this->container['country'] = $country;

        return $this;
    }

    /**
     * Gets referral
     *
     * @return string
     */
    public function getReferral()
    {
        return $this->container['referral'];
    }

    /**
     * Sets referral
     *
     * @param string $referral holds value for referral ID
     *
     * @return $this
     */
    public function setReferral($referral)
    {
        $this->container['referral'] = $referral;

        return $this;
    }

    /**
     * Gets facebook_id
     *
     * @return string
     */
    public function getFacebookId()
    {
        return $this->container['facebook_id'];
    }

    /**
     * Sets facebook_id
     *
     * @param string $facebook_id holds value for facebookId
     *
     * @return $this
     */
    public function setFacebookId($facebook_id)
    {
        $this->container['facebook_id'] = $facebook_id;

        return $this;
    }

    /**
     * Gets twitter_id
     *
     * @return string
     */
    public function getTwitterId()
    {
        return $this->container['twitter_id'];
    }

    /**
     * Sets twitter_id
     *
     * @param string $twitter_id holds value for twitterId
     *
     * @return $this
     */
    public function setTwitterId($twitter_id)
    {
        $this->container['twitter_id'] = $twitter_id;

        return $this;
    }

    /**
     * Gets instagram_id
     *
     * @return string
     */
    public function getInstagramId()
    {
        return $this->container['instagram_id'];
    }

    /**
     * Sets instagram_id
     *
     * @param string $instagram_id holds value for instagramId
     *
     * @return $this
     */
    public function setInstagramId($instagram_id)
    {
        $this->container['instagram_id'] = $instagram_id;

        return $this;
    }

    /**
     * Gets currency
     *
     * @return string
     */
    public function getCurrency()
    {
        return $this->container['currency'];
    }

    /**
     * Sets currency
     *
     * @param string $currency holds value for currency
     *
     * @return $this
     */
    public function setCurrency($currency)
    {
        $this->container['currency'] = $currency;

        return $this;
    }

    /**
     * Gets category
     *
     * @return string
     */
    public function getCategory()
    {
        return $this->container['category'];
    }

    /**
     * Sets category
     *
     * @param string $category holds value for category
     *
     * @return $this
     */
    public function setCategory($category)
    {
        $this->container['category'] = $category;

        return $this;
    }

    /**
     * Gets cac_no
     *
     * @return string
     */
    public function getCacNo()
    {
        return $this->container['cac_no'];
    }

    /**
     * Sets cac_no
     *
     * @param string $cac_no holds value for cacNo
     *
     * @return $this
     */
    public function setCacNo($cac_no)
    {
        $this->container['cac_no'] = $cac_no;

        return $this;
    }

    /**
     * Gets bvn_no
     *
     * @return string
     */
    public function getBvnNo()
    {
        return $this->container['bvn_no'];
    }

    /**
     * Sets bvn_no
     *
     * @param string $bvn_no holds value for bvnNo
     *
     * @return $this
     */
    public function setBvnNo($bvn_no)
    {
        $this->container['bvn_no'] = $bvn_no;

        return $this;
    }

    /**
     * Gets tin_no
     *
     * @return string
     */
    public function getTinNo()
    {
        return $this->container['tin_no'];
    }

    /**
     * Sets tin_no
     *
     * @param string $tin_no holds value for tinNo
     *
     * @return $this
     */
    public function setTinNo($tin_no)
    {
        $this->container['tin_no'] = $tin_no;

        return $this;
    }

    /**
     * Gets about_store
     *
     * @return string
     */
    public function getAboutStore()
    {
        return $this->container['about_store'];
    }

    /**
     * Sets about_store
     *
     * @param string $about_store holds value for aboutStore
     *
     * @return $this
     */
    public function setAboutStore($about_store)
    {
        $this->container['about_store'] = $about_store;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
