<?php
/**
 * StoreHarmonyInventoryApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Store Harmony v3 Merchant API
 *
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)
 *
 * OpenAPI spec version: 1.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\com.storeharmony.api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * StoreHarmonyInventoryApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class StoreHarmonyInventoryApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation listStoreInventory
     *
     * retrieve list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function listStoreInventory($storeid)
    {
        list($response) = $this->listStoreInventoryWithHttpInfo($storeid);
        return $response;
    }

    /**
     * Operation listStoreInventoryWithHttpInfo
     *
     * retrieve list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function listStoreInventoryWithHttpInfo($storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->listStoreInventoryRequest($storeid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation listStoreInventoryAsync
     *
     * retrieve list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function listStoreInventoryAsync($storeid)
    {
        return $this->listStoreInventoryAsyncWithHttpInfo($storeid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation listStoreInventoryAsyncWithHttpInfo
     *
     * retrieve list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function listStoreInventoryAsyncWithHttpInfo($storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->listStoreInventoryRequest($storeid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'listStoreInventory'
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function listStoreInventoryRequest($storeid)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling listStoreInventory'
            );
        }

        $resourcePath = '/{storeid}/inventory';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation listStoreInventoryPaged
     *
     * retrieve list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function listStoreInventoryPaged($storeid, $start, $size)
    {
        list($response) = $this->listStoreInventoryPagedWithHttpInfo($storeid, $start, $size);
        return $response;
    }

    /**
     * Operation listStoreInventoryPagedWithHttpInfo
     *
     * retrieve list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function listStoreInventoryPagedWithHttpInfo($storeid, $start, $size)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->listStoreInventoryPagedRequest($storeid, $start, $size);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation listStoreInventoryPagedAsync
     *
     * retrieve list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function listStoreInventoryPagedAsync($storeid, $start, $size)
    {
        return $this->listStoreInventoryPagedAsyncWithHttpInfo($storeid, $start, $size)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation listStoreInventoryPagedAsyncWithHttpInfo
     *
     * retrieve list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function listStoreInventoryPagedAsyncWithHttpInfo($storeid, $start, $size)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->listStoreInventoryPagedRequest($storeid, $start, $size);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'listStoreInventoryPaged'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function listStoreInventoryPagedRequest($storeid, $start, $size)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling listStoreInventoryPaged'
            );
        }
        // verify the required parameter 'start' is set
        if ($start === null || (is_array($start) && count($start) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $start when calling listStoreInventoryPaged'
            );
        }
        // verify the required parameter 'size' is set
        if ($size === null || (is_array($size) && count($size) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $size when calling listStoreInventoryPaged'
            );
        }

        $resourcePath = '/{storeid}/{start}/{size}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($start !== null) {
            $resourcePath = str_replace(
                '{' . 'start' . '}',
                ObjectSerializer::toPathValue($start),
                $resourcePath
            );
        }
        // path params
        if ($size !== null) {
            $resourcePath = str_replace(
                '{' . 'size' . '}',
                ObjectSerializer::toPathValue($size),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation loadStoreCategories
     *
     * retrieve list of products categories from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function loadStoreCategories($storeid)
    {
        list($response) = $this->loadStoreCategoriesWithHttpInfo($storeid);
        return $response;
    }

    /**
     * Operation loadStoreCategoriesWithHttpInfo
     *
     * retrieve list of products categories from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function loadStoreCategoriesWithHttpInfo($storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreCategoriesRequest($storeid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation loadStoreCategoriesAsync
     *
     * retrieve list of products categories from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreCategoriesAsync($storeid)
    {
        return $this->loadStoreCategoriesAsyncWithHttpInfo($storeid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation loadStoreCategoriesAsyncWithHttpInfo
     *
     * retrieve list of products categories from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreCategoriesAsyncWithHttpInfo($storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreCategoriesRequest($storeid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'loadStoreCategories'
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function loadStoreCategoriesRequest($storeid)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling loadStoreCategories'
            );
        }

        $resourcePath = '/{storeid}/categories';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation loadStoreItem
     *
     * retrieve a product from the store getting its price, details and availability
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function loadStoreItem($storeid, $itemid)
    {
        list($response) = $this->loadStoreItemWithHttpInfo($storeid, $itemid);
        return $response;
    }

    /**
     * Operation loadStoreItemWithHttpInfo
     *
     * retrieve a product from the store getting its price, details and availability
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function loadStoreItemWithHttpInfo($storeid, $itemid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemRequest($storeid, $itemid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation loadStoreItemAsync
     *
     * retrieve a product from the store getting its price, details and availability
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemAsync($storeid, $itemid)
    {
        return $this->loadStoreItemAsyncWithHttpInfo($storeid, $itemid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation loadStoreItemAsyncWithHttpInfo
     *
     * retrieve a product from the store getting its price, details and availability
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemAsyncWithHttpInfo($storeid, $itemid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemRequest($storeid, $itemid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'loadStoreItem'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function loadStoreItemRequest($storeid, $itemid)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling loadStoreItem'
            );
        }
        // verify the required parameter 'itemid' is set
        if ($itemid === null || (is_array($itemid) && count($itemid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $itemid when calling loadStoreItem'
            );
        }

        $resourcePath = '/{storeid}/{itemid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($itemid !== null) {
            $resourcePath = str_replace(
                '{' . 'itemid' . '}',
                ObjectSerializer::toPathValue($itemid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation loadStoreItemBySlug
     *
     * retrieve a product from the store getting its price, details and availability via a slug
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $slug The slug carrying the ID or slug of the product being loaded (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function loadStoreItemBySlug($storeid, $slug)
    {
        list($response) = $this->loadStoreItemBySlugWithHttpInfo($storeid, $slug);
        return $response;
    }

    /**
     * Operation loadStoreItemBySlugWithHttpInfo
     *
     * retrieve a product from the store getting its price, details and availability via a slug
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $slug The slug carrying the ID or slug of the product being loaded (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function loadStoreItemBySlugWithHttpInfo($storeid, $slug)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemBySlugRequest($storeid, $slug);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation loadStoreItemBySlugAsync
     *
     * retrieve a product from the store getting its price, details and availability via a slug
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $slug The slug carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemBySlugAsync($storeid, $slug)
    {
        return $this->loadStoreItemBySlugAsyncWithHttpInfo($storeid, $slug)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation loadStoreItemBySlugAsyncWithHttpInfo
     *
     * retrieve a product from the store getting its price, details and availability via a slug
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $slug The slug carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemBySlugAsyncWithHttpInfo($storeid, $slug)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemBySlugRequest($storeid, $slug);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'loadStoreItemBySlug'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $slug The slug carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function loadStoreItemBySlugRequest($storeid, $slug)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling loadStoreItemBySlug'
            );
        }
        // verify the required parameter 'slug' is set
        if ($slug === null || (is_array($slug) && count($slug) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $slug when calling loadStoreItemBySlug'
            );
        }

        $resourcePath = '/{storeid}/slug/{slug}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($slug !== null) {
            $resourcePath = str_replace(
                '{' . 'slug' . '}',
                ObjectSerializer::toPathValue($slug),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation loadStoreItemByUniqueId
     *
     * retrieve a product from the store getting its price, details and availability
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function loadStoreItemByUniqueId($storeid, $itemid)
    {
        list($response) = $this->loadStoreItemByUniqueIdWithHttpInfo($storeid, $itemid);
        return $response;
    }

    /**
     * Operation loadStoreItemByUniqueIdWithHttpInfo
     *
     * retrieve a product from the store getting its price, details and availability
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function loadStoreItemByUniqueIdWithHttpInfo($storeid, $itemid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemByUniqueIdRequest($storeid, $itemid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation loadStoreItemByUniqueIdAsync
     *
     * retrieve a product from the store getting its price, details and availability
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemByUniqueIdAsync($storeid, $itemid)
    {
        return $this->loadStoreItemByUniqueIdAsyncWithHttpInfo($storeid, $itemid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation loadStoreItemByUniqueIdAsyncWithHttpInfo
     *
     * retrieve a product from the store getting its price, details and availability
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemByUniqueIdAsyncWithHttpInfo($storeid, $itemid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemByUniqueIdRequest($storeid, $itemid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'loadStoreItemByUniqueId'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $itemid The itemid carrying the ID or slug of the product being loaded (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function loadStoreItemByUniqueIdRequest($storeid, $itemid)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling loadStoreItemByUniqueId'
            );
        }
        // verify the required parameter 'itemid' is set
        if ($itemid === null || (is_array($itemid) && count($itemid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $itemid when calling loadStoreItemByUniqueId'
            );
        }

        $resourcePath = '/{storeid}/id/{itemid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($itemid !== null) {
            $resourcePath = str_replace(
                '{' . 'itemid' . '}',
                ObjectSerializer::toPathValue($itemid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation loadStoreItemsForCategory
     *
     * searches and retrieves a list of products from the merchant store for category
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The category id returned from categories call. See /storeid/categories (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function loadStoreItemsForCategory($storeid, $categoryid)
    {
        list($response) = $this->loadStoreItemsForCategoryWithHttpInfo($storeid, $categoryid);
        return $response;
    }

    /**
     * Operation loadStoreItemsForCategoryWithHttpInfo
     *
     * searches and retrieves a list of products from the merchant store for category
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The category id returned from categories call. See /storeid/categories (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function loadStoreItemsForCategoryWithHttpInfo($storeid, $categoryid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemsForCategoryRequest($storeid, $categoryid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation loadStoreItemsForCategoryAsync
     *
     * searches and retrieves a list of products from the merchant store for category
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The category id returned from categories call. See /storeid/categories (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemsForCategoryAsync($storeid, $categoryid)
    {
        return $this->loadStoreItemsForCategoryAsyncWithHttpInfo($storeid, $categoryid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation loadStoreItemsForCategoryAsyncWithHttpInfo
     *
     * searches and retrieves a list of products from the merchant store for category
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The category id returned from categories call. See /storeid/categories (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemsForCategoryAsyncWithHttpInfo($storeid, $categoryid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemsForCategoryRequest($storeid, $categoryid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'loadStoreItemsForCategory'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The category id returned from categories call. See /storeid/categories (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function loadStoreItemsForCategoryRequest($storeid, $categoryid)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling loadStoreItemsForCategory'
            );
        }
        // verify the required parameter 'categoryid' is set
        if ($categoryid === null || (is_array($categoryid) && count($categoryid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $categoryid when calling loadStoreItemsForCategory'
            );
        }

        $resourcePath = '/{storeid}/category/{categoryid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($categoryid !== null) {
            $resourcePath = str_replace(
                '{' . 'categoryid' . '}',
                ObjectSerializer::toPathValue($categoryid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation loadStoreItemsForCategoryByPages
     *
     * searches and retrieves a list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The categoryid of the category (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function loadStoreItemsForCategoryByPages($storeid, $categoryid, $start, $size)
    {
        list($response) = $this->loadStoreItemsForCategoryByPagesWithHttpInfo($storeid, $categoryid, $start, $size);
        return $response;
    }

    /**
     * Operation loadStoreItemsForCategoryByPagesWithHttpInfo
     *
     * searches and retrieves a list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The categoryid of the category (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function loadStoreItemsForCategoryByPagesWithHttpInfo($storeid, $categoryid, $start, $size)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemsForCategoryByPagesRequest($storeid, $categoryid, $start, $size);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation loadStoreItemsForCategoryByPagesAsync
     *
     * searches and retrieves a list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The categoryid of the category (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemsForCategoryByPagesAsync($storeid, $categoryid, $start, $size)
    {
        return $this->loadStoreItemsForCategoryByPagesAsyncWithHttpInfo($storeid, $categoryid, $start, $size)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation loadStoreItemsForCategoryByPagesAsyncWithHttpInfo
     *
     * searches and retrieves a list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The categoryid of the category (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadStoreItemsForCategoryByPagesAsyncWithHttpInfo($storeid, $categoryid, $start, $size)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadStoreItemsForCategoryByPagesRequest($storeid, $categoryid, $start, $size);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'loadStoreItemsForCategoryByPages'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $categoryid The categoryid of the category (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function loadStoreItemsForCategoryByPagesRequest($storeid, $categoryid, $start, $size)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling loadStoreItemsForCategoryByPages'
            );
        }
        // verify the required parameter 'categoryid' is set
        if ($categoryid === null || (is_array($categoryid) && count($categoryid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $categoryid when calling loadStoreItemsForCategoryByPages'
            );
        }
        // verify the required parameter 'start' is set
        if ($start === null || (is_array($start) && count($start) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $start when calling loadStoreItemsForCategoryByPages'
            );
        }
        // verify the required parameter 'size' is set
        if ($size === null || (is_array($size) && count($size) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $size when calling loadStoreItemsForCategoryByPages'
            );
        }

        $resourcePath = '/{storeid}/category/{categoryid}/{start}/{size}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($categoryid !== null) {
            $resourcePath = str_replace(
                '{' . 'categoryid' . '}',
                ObjectSerializer::toPathValue($categoryid),
                $resourcePath
            );
        }
        // path params
        if ($start !== null) {
            $resourcePath = str_replace(
                '{' . 'start' . '}',
                ObjectSerializer::toPathValue($start),
                $resourcePath
            );
        }
        // path params
        if ($size !== null) {
            $resourcePath = str_replace(
                '{' . 'size' . '}',
                ObjectSerializer::toPathValue($size),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation searchStoreRecords
     *
     * searches and retrieves a list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $query The query string (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function searchStoreRecords($storeid, $query, $start, $size)
    {
        list($response) = $this->searchStoreRecordsWithHttpInfo($storeid, $query, $start, $size);
        return $response;
    }

    /**
     * Operation searchStoreRecordsWithHttpInfo
     *
     * searches and retrieves a list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $query The query string (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function searchStoreRecordsWithHttpInfo($storeid, $query, $start, $size)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->searchStoreRecordsRequest($storeid, $query, $start, $size);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation searchStoreRecordsAsync
     *
     * searches and retrieves a list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $query The query string (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchStoreRecordsAsync($storeid, $query, $start, $size)
    {
        return $this->searchStoreRecordsAsyncWithHttpInfo($storeid, $query, $start, $size)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation searchStoreRecordsAsyncWithHttpInfo
     *
     * searches and retrieves a list of products from the merchant store
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $query The query string (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchStoreRecordsAsyncWithHttpInfo($storeid, $query, $start, $size)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->searchStoreRecordsRequest($storeid, $query, $start, $size);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'searchStoreRecords'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $query The query string (required)
     * @param  string $start The start of page of listed products (required)
     * @param  string $size The size of page of listed products (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function searchStoreRecordsRequest($storeid, $query, $start, $size)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling searchStoreRecords'
            );
        }
        // verify the required parameter 'query' is set
        if ($query === null || (is_array($query) && count($query) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $query when calling searchStoreRecords'
            );
        }
        // verify the required parameter 'start' is set
        if ($start === null || (is_array($start) && count($start) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $start when calling searchStoreRecords'
            );
        }
        // verify the required parameter 'size' is set
        if ($size === null || (is_array($size) && count($size) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $size when calling searchStoreRecords'
            );
        }

        $resourcePath = '/{storeid}/{query}/{start}/{size}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($query !== null) {
            $resourcePath = str_replace(
                '{' . 'query' . '}',
                ObjectSerializer::toPathValue($query),
                $resourcePath
            );
        }
        // path params
        if ($start !== null) {
            $resourcePath = str_replace(
                '{' . 'start' . '}',
                ObjectSerializer::toPathValue($start),
                $resourcePath
            );
        }
        // path params
        if ($size !== null) {
            $resourcePath = str_replace(
                '{' . 'size' . '}',
                ObjectSerializer::toPathValue($size),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation searchStoreRecordsMore
     *
     * retrieve list of products from the merchant store
     *
     * @param  \Swagger\Client\com.storeharmony.api\AdvancedQuery $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function searchStoreRecordsMore($body, $storeid)
    {
        list($response) = $this->searchStoreRecordsMoreWithHttpInfo($body, $storeid);
        return $response;
    }

    /**
     * Operation searchStoreRecordsMoreWithHttpInfo
     *
     * retrieve list of products from the merchant store
     *
     * @param  \Swagger\Client\com.storeharmony.api\AdvancedQuery $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function searchStoreRecordsMoreWithHttpInfo($body, $storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->searchStoreRecordsMoreRequest($body, $storeid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation searchStoreRecordsMoreAsync
     *
     * retrieve list of products from the merchant store
     *
     * @param  \Swagger\Client\com.storeharmony.api\AdvancedQuery $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchStoreRecordsMoreAsync($body, $storeid)
    {
        return $this->searchStoreRecordsMoreAsyncWithHttpInfo($body, $storeid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation searchStoreRecordsMoreAsyncWithHttpInfo
     *
     * retrieve list of products from the merchant store
     *
     * @param  \Swagger\Client\com.storeharmony.api\AdvancedQuery $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchStoreRecordsMoreAsyncWithHttpInfo($body, $storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->searchStoreRecordsMoreRequest($body, $storeid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'searchStoreRecordsMore'
     *
     * @param  \Swagger\Client\com.storeharmony.api\AdvancedQuery $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function searchStoreRecordsMoreRequest($body, $storeid)
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling searchStoreRecordsMore'
            );
        }
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling searchStoreRecordsMore'
            );
        }

        $resourcePath = '/{storeid}/search';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
