<?php
/**
 * StoreHarmonyOrderingApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Store Harmony v3 Merchant API
 *
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)
 *
 * OpenAPI spec version: 1.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\com.storeharmony.api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * StoreHarmonyOrderingApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class StoreHarmonyOrderingApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation loadDeliveryServices
     *
     * retrieves the list of delivery services according to the zones supported by the store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function loadDeliveryServices($storeid)
    {
        list($response) = $this->loadDeliveryServicesWithHttpInfo($storeid);
        return $response;
    }

    /**
     * Operation loadDeliveryServicesWithHttpInfo
     *
     * retrieves the list of delivery services according to the zones supported by the store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function loadDeliveryServicesWithHttpInfo($storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadDeliveryServicesRequest($storeid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation loadDeliveryServicesAsync
     *
     * retrieves the list of delivery services according to the zones supported by the store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadDeliveryServicesAsync($storeid)
    {
        return $this->loadDeliveryServicesAsyncWithHttpInfo($storeid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation loadDeliveryServicesAsyncWithHttpInfo
     *
     * retrieves the list of delivery services according to the zones supported by the store
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function loadDeliveryServicesAsyncWithHttpInfo($storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->loadDeliveryServicesRequest($storeid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'loadDeliveryServices'
     *
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function loadDeliveryServicesRequest($storeid)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling loadDeliveryServices'
            );
        }

        $resourcePath = '/{storeid}/delivery_services';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation payForOrderViaCustomGateway
     *
     * After an order has been placed and created with Storeharmony, the client can retrieve the order ID and use it to generate payment reference on their custom gateway implementation. They can use this call to pass the reference back to the storeharmony to use to verify the payment has been made. Popular gateways supported includes 'pastack', 'flutterwave', 'global accelerex', 'sterling'
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrderPayment $body Details of payment for an order (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function payForOrderViaCustomGateway($body, $storeid)
    {
        list($response) = $this->payForOrderViaCustomGatewayWithHttpInfo($body, $storeid);
        return $response;
    }

    /**
     * Operation payForOrderViaCustomGatewayWithHttpInfo
     *
     * After an order has been placed and created with Storeharmony, the client can retrieve the order ID and use it to generate payment reference on their custom gateway implementation. They can use this call to pass the reference back to the storeharmony to use to verify the payment has been made. Popular gateways supported includes 'pastack', 'flutterwave', 'global accelerex', 'sterling'
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrderPayment $body Details of payment for an order (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function payForOrderViaCustomGatewayWithHttpInfo($body, $storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->payForOrderViaCustomGatewayRequest($body, $storeid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation payForOrderViaCustomGatewayAsync
     *
     * After an order has been placed and created with Storeharmony, the client can retrieve the order ID and use it to generate payment reference on their custom gateway implementation. They can use this call to pass the reference back to the storeharmony to use to verify the payment has been made. Popular gateways supported includes 'pastack', 'flutterwave', 'global accelerex', 'sterling'
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrderPayment $body Details of payment for an order (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function payForOrderViaCustomGatewayAsync($body, $storeid)
    {
        return $this->payForOrderViaCustomGatewayAsyncWithHttpInfo($body, $storeid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation payForOrderViaCustomGatewayAsyncWithHttpInfo
     *
     * After an order has been placed and created with Storeharmony, the client can retrieve the order ID and use it to generate payment reference on their custom gateway implementation. They can use this call to pass the reference back to the storeharmony to use to verify the payment has been made. Popular gateways supported includes 'pastack', 'flutterwave', 'global accelerex', 'sterling'
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrderPayment $body Details of payment for an order (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function payForOrderViaCustomGatewayAsyncWithHttpInfo($body, $storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->payForOrderViaCustomGatewayRequest($body, $storeid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'payForOrderViaCustomGateway'
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrderPayment $body Details of payment for an order (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function payForOrderViaCustomGatewayRequest($body, $storeid)
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling payForOrderViaCustomGateway'
            );
        }
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling payForOrderViaCustomGateway'
            );
        }

        $resourcePath = '/{storeid}/order/pay';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation payForOrderViaInternalGateway
     *
     * After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment. Gateway settngs are made via customer settings
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function payForOrderViaInternalGateway($storeid, $orderid)
    {
        list($response) = $this->payForOrderViaInternalGatewayWithHttpInfo($storeid, $orderid);
        return $response;
    }

    /**
     * Operation payForOrderViaInternalGatewayWithHttpInfo
     *
     * After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment. Gateway settngs are made via customer settings
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function payForOrderViaInternalGatewayWithHttpInfo($storeid, $orderid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->payForOrderViaInternalGatewayRequest($storeid, $orderid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation payForOrderViaInternalGatewayAsync
     *
     * After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment. Gateway settngs are made via customer settings
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function payForOrderViaInternalGatewayAsync($storeid, $orderid)
    {
        return $this->payForOrderViaInternalGatewayAsyncWithHttpInfo($storeid, $orderid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation payForOrderViaInternalGatewayAsyncWithHttpInfo
     *
     * After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment. Gateway settngs are made via customer settings
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function payForOrderViaInternalGatewayAsyncWithHttpInfo($storeid, $orderid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->payForOrderViaInternalGatewayRequest($storeid, $orderid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'payForOrderViaInternalGateway'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function payForOrderViaInternalGatewayRequest($storeid, $orderid)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling payForOrderViaInternalGateway'
            );
        }
        // verify the required parameter 'orderid' is set
        if ($orderid === null || (is_array($orderid) && count($orderid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $orderid when calling payForOrderViaInternalGateway'
            );
        }

        $resourcePath = '/{storeid}/order/pay/{orderid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($orderid !== null) {
            $resourcePath = str_replace(
                '{' . 'orderid' . '}',
                ObjectSerializer::toPathValue($orderid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation placeOrderToStore
     *
     * places order of listed products to the merchant store. Note that a payment redirect link is also returned which allows the current buyer to make payment into this store if required. An implementation will redirect the customer to this link and later use /storeid/orderid to track the status of payment on this particular order
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrder $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function placeOrderToStore($body, $storeid)
    {
        list($response) = $this->placeOrderToStoreWithHttpInfo($body, $storeid);
        return $response;
    }

    /**
     * Operation placeOrderToStoreWithHttpInfo
     *
     * places order of listed products to the merchant store. Note that a payment redirect link is also returned which allows the current buyer to make payment into this store if required. An implementation will redirect the customer to this link and later use /storeid/orderid to track the status of payment on this particular order
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrder $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function placeOrderToStoreWithHttpInfo($body, $storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->placeOrderToStoreRequest($body, $storeid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation placeOrderToStoreAsync
     *
     * places order of listed products to the merchant store. Note that a payment redirect link is also returned which allows the current buyer to make payment into this store if required. An implementation will redirect the customer to this link and later use /storeid/orderid to track the status of payment on this particular order
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrder $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function placeOrderToStoreAsync($body, $storeid)
    {
        return $this->placeOrderToStoreAsyncWithHttpInfo($body, $storeid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation placeOrderToStoreAsyncWithHttpInfo
     *
     * places order of listed products to the merchant store. Note that a payment redirect link is also returned which allows the current buyer to make payment into this store if required. An implementation will redirect the customer to this link and later use /storeid/orderid to track the status of payment on this particular order
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrder $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function placeOrderToStoreAsyncWithHttpInfo($body, $storeid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->placeOrderToStoreRequest($body, $storeid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'placeOrderToStore'
     *
     * @param  \Swagger\Client\com.storeharmony.api\WebOrder $body unique identifier of inventory item (required)
     * @param  string $storeid The store id of the specific store (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function placeOrderToStoreRequest($body, $storeid)
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling placeOrderToStore'
            );
        }
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling placeOrderToStore'
            );
        }

        $resourcePath = '/{storeid}/order';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation verifyOrderPlaced
     *
     * retrieve an Order from the store to check the status
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\com.storeharmony.api\WebStore
     */
    public function verifyOrderPlaced($storeid, $orderid)
    {
        list($response) = $this->verifyOrderPlacedWithHttpInfo($storeid, $orderid);
        return $response;
    }

    /**
     * Operation verifyOrderPlacedWithHttpInfo
     *
     * retrieve an Order from the store to check the status
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\com.storeharmony.api\WebStore, HTTP status code, HTTP response headers (array of strings)
     */
    public function verifyOrderPlacedWithHttpInfo($storeid, $orderid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->verifyOrderPlacedRequest($storeid, $orderid);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\com.storeharmony.api\WebStore',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation verifyOrderPlacedAsync
     *
     * retrieve an Order from the store to check the status
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function verifyOrderPlacedAsync($storeid, $orderid)
    {
        return $this->verifyOrderPlacedAsyncWithHttpInfo($storeid, $orderid)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation verifyOrderPlacedAsyncWithHttpInfo
     *
     * retrieve an Order from the store to check the status
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function verifyOrderPlacedAsyncWithHttpInfo($storeid, $orderid)
    {
        $returnType = '\Swagger\Client\com.storeharmony.api\WebStore';
        $request = $this->verifyOrderPlacedRequest($storeid, $orderid);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'verifyOrderPlaced'
     *
     * @param  string $storeid The store id of the specific store (required)
     * @param  string $orderid The orderid of the Order to be traced from the store whi (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function verifyOrderPlacedRequest($storeid, $orderid)
    {
        // verify the required parameter 'storeid' is set
        if ($storeid === null || (is_array($storeid) && count($storeid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $storeid when calling verifyOrderPlaced'
            );
        }
        // verify the required parameter 'orderid' is set
        if ($orderid === null || (is_array($orderid) && count($orderid) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $orderid when calling verifyOrderPlaced'
            );
        }

        $resourcePath = '/{storeid}/order/{orderid}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // path params
        if ($storeid !== null) {
            $resourcePath = str_replace(
                '{' . 'storeid' . '}',
                ObjectSerializer::toPathValue($storeid),
                $resourcePath
            );
        }
        // path params
        if ($orderid !== null) {
            $resourcePath = str_replace(
                '{' . 'orderid' . '}',
                ObjectSerializer::toPathValue($orderid),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
