<?php
/**
 * WebOrder
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Store Harmony v3 Merchant API
 *
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)
 *
 * OpenAPI spec version: 1.0.1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\com.storeharmony.api;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * WebOrder Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class WebOrder implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'WebOrder';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'store_id' => 'string',
'order_id' => 'string',
'developer_key' => 'string',
'firstname' => 'string',
'lastname' => 'string',
'customer_mobile' => 'string',
'customer_email' => 'string',
'delivery_address' => 'string',
'delivery_state' => 'string',
'delivery_country' => 'string',
'order_remark' => 'string',
'client_ip' => 'string',
'coupon_code' => 'string',
'gateway_type' => 'string',
'generate_payment_link' => 'bool',
'payment_redirect_link' => 'string',
'payment_confirm_ref' => 'string',
'payment_gateway' => 'string',
'posted' => 'bool',
'post_response' => 'string',
'total_volume_ordered' => 'float',
'total_order_price' => 'float',
'orders' => '\Swagger\Client\com.storeharmony.api\WebOrderItem[]'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'store_id' => null,
'order_id' => null,
'developer_key' => null,
'firstname' => null,
'lastname' => null,
'customer_mobile' => null,
'customer_email' => null,
'delivery_address' => null,
'delivery_state' => null,
'delivery_country' => null,
'order_remark' => null,
'client_ip' => null,
'coupon_code' => null,
'gateway_type' => null,
'generate_payment_link' => null,
'payment_redirect_link' => null,
'payment_confirm_ref' => null,
'payment_gateway' => null,
'posted' => null,
'post_response' => null,
'total_volume_ordered' => null,
'total_order_price' => null,
'orders' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'store_id' => 'storeId',
'order_id' => 'orderId',
'developer_key' => 'developerKey',
'firstname' => 'firstname',
'lastname' => 'lastname',
'customer_mobile' => 'customerMobile',
'customer_email' => 'customerEmail',
'delivery_address' => 'deliveryAddress',
'delivery_state' => 'deliveryState',
'delivery_country' => 'deliveryCountry',
'order_remark' => 'orderRemark',
'client_ip' => 'clientIp',
'coupon_code' => 'couponCode',
'gateway_type' => 'gatewayType',
'generate_payment_link' => 'generatePaymentLink',
'payment_redirect_link' => 'paymentRedirectLink',
'payment_confirm_ref' => 'paymentConfirmRef',
'payment_gateway' => 'paymentGateway',
'posted' => 'posted',
'post_response' => 'postResponse',
'total_volume_ordered' => 'totalVolumeOrdered',
'total_order_price' => 'totalOrderPrice',
'orders' => 'orders'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'store_id' => 'setStoreId',
'order_id' => 'setOrderId',
'developer_key' => 'setDeveloperKey',
'firstname' => 'setFirstname',
'lastname' => 'setLastname',
'customer_mobile' => 'setCustomerMobile',
'customer_email' => 'setCustomerEmail',
'delivery_address' => 'setDeliveryAddress',
'delivery_state' => 'setDeliveryState',
'delivery_country' => 'setDeliveryCountry',
'order_remark' => 'setOrderRemark',
'client_ip' => 'setClientIp',
'coupon_code' => 'setCouponCode',
'gateway_type' => 'setGatewayType',
'generate_payment_link' => 'setGeneratePaymentLink',
'payment_redirect_link' => 'setPaymentRedirectLink',
'payment_confirm_ref' => 'setPaymentConfirmRef',
'payment_gateway' => 'setPaymentGateway',
'posted' => 'setPosted',
'post_response' => 'setPostResponse',
'total_volume_ordered' => 'setTotalVolumeOrdered',
'total_order_price' => 'setTotalOrderPrice',
'orders' => 'setOrders'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'store_id' => 'getStoreId',
'order_id' => 'getOrderId',
'developer_key' => 'getDeveloperKey',
'firstname' => 'getFirstname',
'lastname' => 'getLastname',
'customer_mobile' => 'getCustomerMobile',
'customer_email' => 'getCustomerEmail',
'delivery_address' => 'getDeliveryAddress',
'delivery_state' => 'getDeliveryState',
'delivery_country' => 'getDeliveryCountry',
'order_remark' => 'getOrderRemark',
'client_ip' => 'getClientIp',
'coupon_code' => 'getCouponCode',
'gateway_type' => 'getGatewayType',
'generate_payment_link' => 'getGeneratePaymentLink',
'payment_redirect_link' => 'getPaymentRedirectLink',
'payment_confirm_ref' => 'getPaymentConfirmRef',
'payment_gateway' => 'getPaymentGateway',
'posted' => 'getPosted',
'post_response' => 'getPostResponse',
'total_volume_ordered' => 'getTotalVolumeOrdered',
'total_order_price' => 'getTotalOrderPrice',
'orders' => 'getOrders'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['store_id'] = isset($data['store_id']) ? $data['store_id'] : null;
        $this->container['order_id'] = isset($data['order_id']) ? $data['order_id'] : null;
        $this->container['developer_key'] = isset($data['developer_key']) ? $data['developer_key'] : null;
        $this->container['firstname'] = isset($data['firstname']) ? $data['firstname'] : null;
        $this->container['lastname'] = isset($data['lastname']) ? $data['lastname'] : null;
        $this->container['customer_mobile'] = isset($data['customer_mobile']) ? $data['customer_mobile'] : null;
        $this->container['customer_email'] = isset($data['customer_email']) ? $data['customer_email'] : null;
        $this->container['delivery_address'] = isset($data['delivery_address']) ? $data['delivery_address'] : null;
        $this->container['delivery_state'] = isset($data['delivery_state']) ? $data['delivery_state'] : null;
        $this->container['delivery_country'] = isset($data['delivery_country']) ? $data['delivery_country'] : null;
        $this->container['order_remark'] = isset($data['order_remark']) ? $data['order_remark'] : null;
        $this->container['client_ip'] = isset($data['client_ip']) ? $data['client_ip'] : null;
        $this->container['coupon_code'] = isset($data['coupon_code']) ? $data['coupon_code'] : null;
        $this->container['gateway_type'] = isset($data['gateway_type']) ? $data['gateway_type'] : null;
        $this->container['generate_payment_link'] = isset($data['generate_payment_link']) ? $data['generate_payment_link'] : null;
        $this->container['payment_redirect_link'] = isset($data['payment_redirect_link']) ? $data['payment_redirect_link'] : null;
        $this->container['payment_confirm_ref'] = isset($data['payment_confirm_ref']) ? $data['payment_confirm_ref'] : null;
        $this->container['payment_gateway'] = isset($data['payment_gateway']) ? $data['payment_gateway'] : null;
        $this->container['posted'] = isset($data['posted']) ? $data['posted'] : null;
        $this->container['post_response'] = isset($data['post_response']) ? $data['post_response'] : null;
        $this->container['total_volume_ordered'] = isset($data['total_volume_ordered']) ? $data['total_volume_ordered'] : null;
        $this->container['total_order_price'] = isset($data['total_order_price']) ? $data['total_order_price'] : null;
        $this->container['orders'] = isset($data['orders']) ? $data['orders'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets store_id
     *
     * @return string
     */
    public function getStoreId()
    {
        return $this->container['store_id'];
    }

    /**
     * Sets store_id
     *
     * @param string $store_id holds value for storeId
     *
     * @return $this
     */
    public function setStoreId($store_id)
    {
        $this->container['store_id'] = $store_id;

        return $this;
    }

    /**
     * Gets order_id
     *
     * @return string
     */
    public function getOrderId()
    {
        return $this->container['order_id'];
    }

    /**
     * Sets order_id
     *
     * @param string $order_id holds value for orderId
     *
     * @return $this
     */
    public function setOrderId($order_id)
    {
        $this->container['order_id'] = $order_id;

        return $this;
    }

    /**
     * Gets developer_key
     *
     * @return string
     */
    public function getDeveloperKey()
    {
        return $this->container['developer_key'];
    }

    /**
     * Sets developer_key
     *
     * @param string $developer_key holds value for developerKey
     *
     * @return $this
     */
    public function setDeveloperKey($developer_key)
    {
        $this->container['developer_key'] = $developer_key;

        return $this;
    }

    /**
     * Gets firstname
     *
     * @return string
     */
    public function getFirstname()
    {
        return $this->container['firstname'];
    }

    /**
     * Sets firstname
     *
     * @param string $firstname holds value for firstname
     *
     * @return $this
     */
    public function setFirstname($firstname)
    {
        $this->container['firstname'] = $firstname;

        return $this;
    }

    /**
     * Gets lastname
     *
     * @return string
     */
    public function getLastname()
    {
        return $this->container['lastname'];
    }

    /**
     * Sets lastname
     *
     * @param string $lastname holds value for lastname
     *
     * @return $this
     */
    public function setLastname($lastname)
    {
        $this->container['lastname'] = $lastname;

        return $this;
    }

    /**
     * Gets customer_mobile
     *
     * @return string
     */
    public function getCustomerMobile()
    {
        return $this->container['customer_mobile'];
    }

    /**
     * Sets customer_mobile
     *
     * @param string $customer_mobile holds value for customerMobile
     *
     * @return $this
     */
    public function setCustomerMobile($customer_mobile)
    {
        $this->container['customer_mobile'] = $customer_mobile;

        return $this;
    }

    /**
     * Gets customer_email
     *
     * @return string
     */
    public function getCustomerEmail()
    {
        return $this->container['customer_email'];
    }

    /**
     * Sets customer_email
     *
     * @param string $customer_email holds value for customerEmail
     *
     * @return $this
     */
    public function setCustomerEmail($customer_email)
    {
        $this->container['customer_email'] = $customer_email;

        return $this;
    }

    /**
     * Gets delivery_address
     *
     * @return string
     */
    public function getDeliveryAddress()
    {
        return $this->container['delivery_address'];
    }

    /**
     * Sets delivery_address
     *
     * @param string $delivery_address holds value for deliveryAddress
     *
     * @return $this
     */
    public function setDeliveryAddress($delivery_address)
    {
        $this->container['delivery_address'] = $delivery_address;

        return $this;
    }

    /**
     * Gets delivery_state
     *
     * @return string
     */
    public function getDeliveryState()
    {
        return $this->container['delivery_state'];
    }

    /**
     * Sets delivery_state
     *
     * @param string $delivery_state holds value for deliveryState
     *
     * @return $this
     */
    public function setDeliveryState($delivery_state)
    {
        $this->container['delivery_state'] = $delivery_state;

        return $this;
    }

    /**
     * Gets delivery_country
     *
     * @return string
     */
    public function getDeliveryCountry()
    {
        return $this->container['delivery_country'];
    }

    /**
     * Sets delivery_country
     *
     * @param string $delivery_country holds value for deliveryCountry
     *
     * @return $this
     */
    public function setDeliveryCountry($delivery_country)
    {
        $this->container['delivery_country'] = $delivery_country;

        return $this;
    }

    /**
     * Gets order_remark
     *
     * @return string
     */
    public function getOrderRemark()
    {
        return $this->container['order_remark'];
    }

    /**
     * Sets order_remark
     *
     * @param string $order_remark holds value for orderRemark
     *
     * @return $this
     */
    public function setOrderRemark($order_remark)
    {
        $this->container['order_remark'] = $order_remark;

        return $this;
    }

    /**
     * Gets client_ip
     *
     * @return string
     */
    public function getClientIp()
    {
        return $this->container['client_ip'];
    }

    /**
     * Sets client_ip
     *
     * @param string $client_ip holds value for clientIp
     *
     * @return $this
     */
    public function setClientIp($client_ip)
    {
        $this->container['client_ip'] = $client_ip;

        return $this;
    }

    /**
     * Gets coupon_code
     *
     * @return string
     */
    public function getCouponCode()
    {
        return $this->container['coupon_code'];
    }

    /**
     * Sets coupon_code
     *
     * @param string $coupon_code holds value for couponCode
     *
     * @return $this
     */
    public function setCouponCode($coupon_code)
    {
        $this->container['coupon_code'] = $coupon_code;

        return $this;
    }

    /**
     * Gets gateway_type
     *
     * @return string
     */
    public function getGatewayType()
    {
        return $this->container['gateway_type'];
    }

    /**
     * Sets gateway_type
     *
     * @param string $gateway_type holds value for gatewayType
     *
     * @return $this
     */
    public function setGatewayType($gateway_type)
    {
        $this->container['gateway_type'] = $gateway_type;

        return $this;
    }

    /**
     * Gets generate_payment_link
     *
     * @return bool
     */
    public function getGeneratePaymentLink()
    {
        return $this->container['generate_payment_link'];
    }

    /**
     * Sets generate_payment_link
     *
     * @param bool $generate_payment_link holds value for generatePaymentLink
     *
     * @return $this
     */
    public function setGeneratePaymentLink($generate_payment_link)
    {
        $this->container['generate_payment_link'] = $generate_payment_link;

        return $this;
    }

    /**
     * Gets payment_redirect_link
     *
     * @return string
     */
    public function getPaymentRedirectLink()
    {
        return $this->container['payment_redirect_link'];
    }

    /**
     * Sets payment_redirect_link
     *
     * @param string $payment_redirect_link holds value for paymentRedirectLink
     *
     * @return $this
     */
    public function setPaymentRedirectLink($payment_redirect_link)
    {
        $this->container['payment_redirect_link'] = $payment_redirect_link;

        return $this;
    }

    /**
     * Gets payment_confirm_ref
     *
     * @return string
     */
    public function getPaymentConfirmRef()
    {
        return $this->container['payment_confirm_ref'];
    }

    /**
     * Sets payment_confirm_ref
     *
     * @param string $payment_confirm_ref holds value for paymentConfirmRef
     *
     * @return $this
     */
    public function setPaymentConfirmRef($payment_confirm_ref)
    {
        $this->container['payment_confirm_ref'] = $payment_confirm_ref;

        return $this;
    }

    /**
     * Gets payment_gateway
     *
     * @return string
     */
    public function getPaymentGateway()
    {
        return $this->container['payment_gateway'];
    }

    /**
     * Sets payment_gateway
     *
     * @param string $payment_gateway holds value for paymentGateway
     *
     * @return $this
     */
    public function setPaymentGateway($payment_gateway)
    {
        $this->container['payment_gateway'] = $payment_gateway;

        return $this;
    }

    /**
     * Gets posted
     *
     * @return bool
     */
    public function getPosted()
    {
        return $this->container['posted'];
    }

    /**
     * Sets posted
     *
     * @param bool $posted holds value for posted
     *
     * @return $this
     */
    public function setPosted($posted)
    {
        $this->container['posted'] = $posted;

        return $this;
    }

    /**
     * Gets post_response
     *
     * @return string
     */
    public function getPostResponse()
    {
        return $this->container['post_response'];
    }

    /**
     * Sets post_response
     *
     * @param string $post_response holds value for postResponse
     *
     * @return $this
     */
    public function setPostResponse($post_response)
    {
        $this->container['post_response'] = $post_response;

        return $this;
    }

    /**
     * Gets total_volume_ordered
     *
     * @return float
     */
    public function getTotalVolumeOrdered()
    {
        return $this->container['total_volume_ordered'];
    }

    /**
     * Sets total_volume_ordered
     *
     * @param float $total_volume_ordered holds value for totalVolumeOrdered
     *
     * @return $this
     */
    public function setTotalVolumeOrdered($total_volume_ordered)
    {
        $this->container['total_volume_ordered'] = $total_volume_ordered;

        return $this;
    }

    /**
     * Gets total_order_price
     *
     * @return float
     */
    public function getTotalOrderPrice()
    {
        return $this->container['total_order_price'];
    }

    /**
     * Sets total_order_price
     *
     * @param float $total_order_price holds value for totalOrderPrice
     *
     * @return $this
     */
    public function setTotalOrderPrice($total_order_price)
    {
        $this->container['total_order_price'] = $total_order_price;

        return $this;
    }

    /**
     * Gets orders
     *
     * @return \Swagger\Client\com.storeharmony.api\WebOrderItem[]
     */
    public function getOrders()
    {
        return $this->container['orders'];
    }

    /**
     * Sets orders
     *
     * @param \Swagger\Client\com.storeharmony.api\WebOrderItem[] $orders orders
     *
     * @return $this
     */
    public function setOrders($orders)
    {
        $this->container['orders'] = $orders;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
